var db, db2, keypad_db;
var mqttUrl = 'wss://52.66.30.178:9001'; //MQTT SERVER ADDRESS
var allMacs = ["00:15:83:00:71:BD", "C4:BE:84:09:FA:65", "A8:1B:6A:AE:A1:8B"];
var globalBLE = "A8:1B:6A:AE:A1:8B";
//===============================INITIALIZE LOCALSTORAGE===================================
try {
    var doorStatus = JSON.parse(localStorage.getItem('doorStatus'));
    if (doorStatus == null) {
        localStorage.setItem('doorStatus', JSON.stringify({}));
    }
} catch (e) {
    localStorage.setItem('doorStatus', JSON.stringify({}));
}
try {
    var loginObj = JSON.parse(localStorage.getItem('login'));
    if (loginObj == null) {
        localStorage.setItem('login', JSON.stringify({
            isLogged: false
        }));
    }
} catch (e) {
    localStorage.setItem('login', JSON.stringify({
        isLogged: false
    }));
}
try {
    var notifications = JSON.parse(localStorage.getItem('notifications'));
    if (notifications == null) {
        var obj = {
            array: []
        }
        localStorage.setItem('notifications', JSON.stringify(obj));
    }
} catch (e) {
    var obj = {
        array: []
    }
    localStorage.setItem('notifications', JSON.stringify(obj));
}
try {
    var locks = JSON.parse(localStorage.getItem('locks'));
    if (locks == null) {
        var obj = {}
        localStorage.setItem('locks', JSON.stringify(obj));
    }
} catch (e) {
    var obj = {}
    localStorage.setItem('locks', JSON.stringify(obj));
}
try {
    var battery = JSON.parse(localStorage.getItem('battery'));
    if (battery.locks == undefined) {
        var obj = {
            locks: []
        }
        localStorage.setItem('battery', JSON.stringify(obj));
    }
    if (battery == null) {
        var obj = {}
        localStorage.setItem('battery', JSON.stringify(obj));
    }
} catch (e) {
    var obj = {
        locks: []
    }
    localStorage.setItem('battery', JSON.stringify(obj));
}

angular.module('app', ['ionic', 'app.controllers', 'app.routes', 'app.directives', 'app.services', 'ngCordova', 'ngCordovaBluetoothLE', 'mgo-angular-wizard'])

// --------------------------------------CONFIG-----------------------------------
.config(function($ionicConfigProvider, $sceDelegateProvider, $httpProvider) {
    $ionicConfigProvider.views.transition('none');
    $ionicConfigProvider.tabs.style('standard');
    $ionicConfigProvider.spinner.icon('android');
    $ionicConfigProvider.templates.maxPrefetch(0);
    $ionicConfigProvider.navBar.alignTitle('center');

    //---------------------------http interceptor---------------------------
    $httpProvider.interceptors.push(function ($q) {
        return {
            request: function (config) {
                if (!config.timeout) {
                    config.cancel  = $q.defer();
                    config.timeout = config.cancel.promise;
                }
                return config;
            }
        }
    });
})

// -------------------------------------RUN-------------------------------------------
.run(function($ionicPlatform, http,$http, ngBLE, guestTimeout, $ionicPopup, $state, $interval, guestlogIn, tools) {
    document.addEventListener('deviceready', function(){
        if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
            cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
        }
        if (window.StatusBar) {
            StatusBar.styleDefault();
        }
        document.addEventListener("pause", onPause, false);
        document.addEventListener("backbutton", function(res){
            ngBLE.disconnect('back button');
            var pendingRequests=$http.pendingRequests;
            for(var i=0;i<pendingRequests.length;i++){
                pendingRequests[i].cancel.resolve('Operation cancelled');
            }
        }, false);

        function onPause() {
            ngBLE.disconnect();
        }

        document.getElementById('mainbody').style.display = "block";
        db = new PouchDB('lock', {});
        // db.destroy();db=new PouchDB('lock', {adapter:'websql'});
        db2 = new PouchDB('admin', {});
        // db2.destroy();db2=new PouchDB('admin', {adapter:'websql'});
        keypad_db = new PouchDB('keypad', {});
        // keypad_db.destroy();keypad_db=new PouchDB('keypad', {adapter:'websql'});
        //==========================IS LOGGED ON SERVER======================
        var loginObj = JSON.parse(localStorage.getItem('login'));
        console.log(loginObj);
        if (loginObj.isLogged == true && loginObj.type == 'admin') {
            var params = {
                adminEmail: loginObj.adminName,
                uuid: (typeof device === 'undefined') ? 'random something' : device.uuid
            }
            
            http.isLogged(params).then(function(res) {
                console.log(params.adminEmail, (res.type===false)?+" is not logged in":" is logged in");
                if (res.type == false) {
                    obj = {
                        isLogged: false
                    }
                    localStorage.setItem('login', JSON.stringify(obj));
                    $state.go('login');
                    return;
                } else {
                    for (var i = 0; i < res.doc.length; i++) {
                        if (res.doc[i].client_id === loginObj.currentLock) {
                            loginObj.lockType = res.doc[i].lockType;
                            if (res.doc[i].alias) loginObj.currentLockName = res.doc[i].alias;
                            else loginObj.currentLockName = res.doc[i].client_id;
                        }
                    }
                    if (loginObj.locks.length > 0) {
                        for (var i = 0; i < res.doc.length; i++) {
                            for (var j = 0; j < loginObj.locks.length; j++) {
                                if (loginObj.locks[j].client_id == res.doc[i].client_id && loginObj.locks[j].lockType !== 'BKW') {
                                    loginObj.locks[j].sub = res.doc[i].sub;
                                    loginObj.locks[j].alias = res.doc[i].alias;
                                    loginObj.locks[j].lockType = res.doc[i].lockType;
                                    loginObj.locks[j].bleId = res.doc[i].bleId;
                                    loginObj.locks[j].mac_id = res.doc[i].mac_id;
                                    loginObj.locks[j].passcode = res.doc[i].passcode;
                                    break;
                                } else if (loginObj.locks[j].client_id == res.doc[i].client_id) {
                                    loginObj.locks[j] = res.doc[i];
                                    break;
                                }
                            }
                        }
                        localStorage.setItem('login', JSON.stringify(loginObj));
                        if (loginObj.lockType === 'BKW') $state.go('home');
                        else $state.go('ble');
                    } else {
                        $state.go('locks');
                    }
                }
                if (navigator && navigator.splashscreen) navigator.splashscreen.hide();
            }, function(err) {
                console.log(err);
                if (navigator && navigator.splashscreen) navigator.splashscreen.hide();
                $state.go('internetLost');
            });
        } else if (loginObj.isLogged == true && loginObj.lockType !== 'BKW') {
            $state.go('ble');
            if (navigator && navigator.splashscreen) navigator.splashscreen.hide();
        } else if (loginObj.isLogged === true && loginObj.type === 'guest') {
            $state.go('ble');
            if (navigator && navigator.splashscreen) navigator.splashscreen.hide();
        } else if (!loginObj.isLogged) {
            $state.go('login');
            if (navigator && navigator.splashscreen) navigator.splashscreen.hide();
        }
        //=======================================================================
        //================================DELETE GUESTS==============================
        var docs = [],
            logs = [];
        db.allDocs({
            include_docs: true
        }, function(error, response) {
            var i;
            for (i = 0; i < response.total_rows; i++) {
                docs.push(response.rows[i].doc);
            }
            var loginObj = JSON.parse(localStorage.getItem('login'));
            if (loginObj.isLogged == true && loginObj.type == 'admin') {
                http.toDelete({
                    adminName: loginObj.adminName
                }, function(res) {
                    var deleted = res.deleted;
                    for (var i = 0; i < deleted.length; i++) {
                        for (var j = 0; j < docs.length; j++) {
                            if (docs[j].keyId === deleted[i].keyId) {
                                db.remove(docs[j]._id, docs[j]._rev, function(error, response) {
                                    // docs.splice(j,1);
                                });
                                break;
                            }
                        }
                    }
                }, function(err) {});
            }
        });
        //==========================================================================
        //=========================DELETE NOTIFICATIONS==============================
        var obj = JSON.parse(localStorage.getItem('notifications'));
        if (obj != null) {
            var deleteArray = [];
            var date = new Date();
            var nowDate = new Date();
            date.setDate(date.getDate() - 7);
            for (var i = 0; i < obj.array.length; i++) {
                var compDate = new Date(obj.array[i].date);
                if (compDate.getTime() > date.getTime() && compDate.getTime() < nowDate.getTime()) {
                    logs.push(obj.array[i]);
                } else {
                    deleteArray.push(i);
                }
            }
        }
        for (var i = 0; i < deleteArray.length; i++) {
            obj.array.splice(deleteArray[i], 1);
            var jsonData = {
                array: obj.array
            }
        }
        if (jsonData != null) {
            localStorage.setItem('notifications', JSON.stringify(jsonData));
        }
    }, false)
    //==================================GUEST TIMER=====================================
    var globalTime = null;
    setInterval(function() {
        var date = new Date();
        if (guestTimeout.checkLogin()) {
            try {
                if (globalTime != null) {
                    var sub = Math.abs(date.getTime() - globalTime.getTime());
                }
                if (sub > 5000 && globalTime != null) {
                    console.log("logout");
                    var loginObj = JSON.parse(localStorage.getItem('login'));
                    loginObj.isLogged = false;
                    localStorage.setItem('login', JSON.stringify(loginObj));
                    $state.go('login');
                    globalTime = null;
                    notificationMsg = "Logout";
                }
            } catch (e) {
                console.log(e);
            }
            var compareDate = new Date(guestTimeout.getTime());
            var loginObj = JSON.parse(localStorage.getItem('login'));
            var alertTime = new Date(loginObj.alertTime);
            if (date > compareDate) {
                console.log("time's up");
                loginObj.isLogged = false;
                localStorage.setItem('login', JSON.stringify(loginObj));
                $state.go('login');
                var popup = $ionicPopup.alert({
                    title: 'Time\'s up'
                });
                popup.then(function() {
                    $state.go('login');
                })
                return;
            }
            if (date > alertTime) {
                loginObj.alertTime = loginObj.checkOut;
                localStorage.setItem('login', JSON.stringify(loginObj));
                var endIn = guestTimeout.getTimeRemaining(compareDate);
                if (alertTime != compareDate) {
                    var popup = $ionicPopup.alert({
                        title: 'Your stay will end in ' + endIn.days + " days " + endIn.hours + " hours " + endIn.minutes + " minutes " + endIn.seconds + " seconds"
                    });
                }
            }
        }
        globalTime = new Date();
    }, 1000);
    //===================================================================================
}).directive('disableSideMenuDrag', ['$ionicSideMenuDelegate', '$rootScope', function($ionicSideMenuDelegate, $rootScope) {
    return {
        restrict: "A",
        controller: ['$scope', '$element', '$attrs', function($scope, $element, $attrs) {
            function stopDrag() {
                $ionicSideMenuDelegate.canDragContent(false);
            }

            function allowDrag() {
                $ionicSideMenuDelegate.canDragContent(true);
            }
            $rootScope.$on('$ionicSlides.slideChangeEnd', allowDrag);
            $element.on('touchstart', stopDrag);
            $element.on('touchend', allowDrag);
            $element.on('mousedown', stopDrag);
            $element.on('mouseup', allowDrag);
        }]
    };
}]).filter('groupBy', ['$parse', function($parse) {
    return function(list, group_by) {
        var filtered = [];
        var prev_item = null;
        var group_changed = false;
        var new_field = 'group_by_CHANGED';
        angular.forEach(list, function(item) {
            group_changed = false;
            if (prev_item !== null) {
                group_by = angular.isArray(group_by) ? group_by : [group_by];
                for (var i = 0, len = group_by.length; i < len; i++) {
                    if ($parse(group_by[i])(prev_item) !== $parse(group_by[i])(item)) {
                        group_changed = true;
                    }
                }
            } else {
                group_changed = true;
            }
            if (group_changed) {
                item[new_field] = true;
            } else {
                item[new_field] = false;
            }
            filtered.push(item);
            prev_item = item;
        });
        return filtered;
    };
}]);