angular.module('app.controllers', []).controller('signupCtrl', function($scope, 
    $state, $stateParams, CheckMAC, $ionicLoading, $ionicPopup, 
    $ionicSideMenuDelegate, registered, tools) {
    $ionicSideMenuDelegate.canDragContent(false);
    $scope.div = true;
    $scope.reg = false;
    $scope.disable = false;
    $scope.name = false;
    $scope.email = false;
    $scope.pwd = false;
    $scope.cno = false;
    $scope.addr = false;
    $scope.register = function() {
        $scope.user.activated = true;
        $scope.user.key = $scope.user.email;
        db2.post($scope.user, function(error, response) { 
            if (error) {
                console.log(error);
            } else if (response) {
                console.log(response);
                $ionicPopup.alert({
                    content: '<center>Registration Successfull!</center>'
                }).then(function() {
                    $state.go('login', {
                        reload: true
                    });
                });
            }
        });
    }
}).controller('loginCtrl', function($scope, $ionicPlatform, $state, $ionicPopup, 
    gener, guestlogIn, $stateParams, logIn, $ionicLoading, $ionicSideMenuDelegate, 
    $ionicHistory, MQTT, Devices, ngBLE, tools, http) {
    $ionicHistory.clearHistory();
    tools.hideLoad();
    $scope.userid = "";
    $ionicSideMenuDelegate.canDragContent(false);
    $scope.gener = gener;
    var adminRecords = [];
    var deviceInfo;
    $scope.loading=$ionicLoading;
    $ionicPlatform.ready(function() {
        adminRecords = [];
        if(typeof device === 'object')
            deviceInfo = device;
        db2.allDocs({
            include_docs: true
        }, function(err, res) {
            for (var i = 0; i < res.rows.length; i++) {
                adminRecords.push(res.rows[i].doc);
            }
        });
    });
    $scope.userLogin = function(role) {
        $scope.loading.show();
        var deviceName = "Ionic";
        var uuid = "random something";
        try{
            deviceName = deviceInfo.manufacturer + " "+ deviceInfo.model;
            uuid = deviceInfo.uuid;
        }catch(e){
            console.log(e);
        }
        if (role == 'Admin') {
            http.adminLogin({
                email: $scope.user.email,
                pwd: $scope.user.pwd,
                device: deviceName,
                uuid: uuid,
                type: 'mobile'
            }).then(function(res) {
                console.log(res);
                if (res.type == true) {
                    var obj = {
                        isLogged: true,
                        type: 'admin',
                        adminName: res.user.email,
                        name: res.user.name,
                        imageUri: "img/profile-icon.png",
                        locks: res.data,
                        bleId: "",
                        macId: ""
                    }
                    var go = "locks";
                    var locks = JSON.parse(localStorage.getItem('locks'));
                    if (obj.locks.length > 0) {
                        for (var i = 0; i < obj.locks.length; i++) {
                            if (obj.locks[i].lockType === "BKW"){
                                console.log("Substcribed to:" + obj.locks[i].mac_id + '/notify');
                                if(typeof FCMPlugin !== 'undefined')
                                    FCMPlugin.subscribeToTopic(obj.locks[i].client_id);
                            }
                        }
                        obj.bleId = res.data[0].ble_id;
                        if (locks == null || locks[res.data[0].client_id] == null || locks[res.data[0].client_id] == "") obj.currentLockName = res.data[0].client_id;
                        else obj.currentLockName = locks[res.data[0].client_id];
                        obj.currentLock = res.data[0].client_id;
                        obj.macId = res.data[0].mac_id;
                        obj.lockType = res.data[0].lockType;
                        obj.passcode = res.data[0].passcode;
                        if (obj.lockType == "BKW") go = "home";
                        else go = "ble";
                    }
                    localStorage.setItem('login', JSON.stringify(obj));
                    console.log(obj);
                    $scope.loading.hide();
                    $ionicPopup.alert({
                        title: 'Proceed',
                        content: '<center>Welcome ' + res.user.name + '!!</center>'
                    }).then(function(res) {
                        $state.go(go, {
                            reload: true
                        });
                    });
                }
            }, function(err) {
                var local = false;
                for (var i = 0; i < adminRecords.length; i++) {
                    if (adminRecords[i].email == $scope.user.email && adminRecords[i].pwd == $scope.user.pwd) {
                        console.log("Admin exists locally.", adminRecords[i]);
                        local = true;
                        var obj = {
                            isLogged: true,
                            type: 'admin',
                            adminName: adminRecords[i].email,
                            name: adminRecords[i].name,
                            imageUri: "img/profile-icon.png",
                            locks: [],
                            bleId: "",
                            data: adminRecords[i]
                        }
                        localStorage.setItem('login', JSON.stringify(obj));
                        $ionicPopup.alert({
                            title: 'Proceed',
                            content: '<center>Welcome ' + adminRecords[i].name + '!!</center>'
                        }).then(function(res) {
                            $state.go('locks', {
                                reload: true
                            });
                        });
                        break;
                    }
                }
                $scope.loading.hide();
                if (local === false) {
                    $ionicPopup.alert({
                        content: '<center>Invalid Credentials!!</center>'
                    });
                }
                // $scope.loading.hide();
                // $ionicPopup.alert({
                //     title: "Login failed!",
                //     template: "<center>"+err.msg+"</center>"
                // });
            });
        }
        if (role == 'Guest') {
            var compareId = $scope.userid;
            if (compareId === "" || compareId.length < 5 || isNaN(compareId.substring(compareId.length - 4, compareId.length))) {
                $scope.loading.hide();
                $ionicPopup.alert({
                    title: "Error",
                    template: "<center>Invalid ID</center>"
                });
                return;
            } else if ($scope.userid.substring(0, 3) !== 'bkw') {
                var guestID = compareId.substring(compareId.length - 4, compareId.length);
                var productID = compareId.substring(0, compareId.length - 4);
                console.log(guestID, productID);
                var params={
                    client_id:productID
                }
                http.getBleId(params).then(function(res) {
                    console.log(res);
                    if (res.type == 'Error') {
                        $scope.loading.hide();
                        $ionicPopup.alert({
                            title: "Error",
                            template: "<center>Product does not exist.</center>"
                        });
                    } else {
                        var template = "<li>Turn Bluetooth ON</li><li>Stay in range of the lock</li>" + "<li>Click OK to continue the login process...";
                        $scope.loading.hide();
                        $ionicPopup.show({
                            template: template,
                            title: "Login process",
                            scope: $scope,
                            buttons: [{
                                text: "Cancel"
                            }, {
                                text: "OK",
                                type: "button-positive",
                                onTap: function(e) {
                                    console.log("authenticate");
                                    var o={
                                        passcode:res.doc.passcode
                                    }
                                    localStorage.setItem('login', JSON.stringify(o));
                                    authenticate(res.doc.bleId, guestID, productID);
                                }
                            }]
                        });
                    }
                }, function(err) {
                    console.log(err);
                })
                return;
            }
            var guestID = $scope.userid.substring($scope.userid.length - 4, $scope.userid.length);
            console.log('guest ' + $scope.userid);
            guestlogIn.authenticate({
                keyId: guestID
            }, function(res) {
                var timestamp = new Date(res.timestamp).getTime();
                var systemDate = new Date().getTime();
                console.log(res);
                if (res.type == true) {
                    var guestTime = new Date(res.data.checkOut);
                    var checkInTime = new Date(res.data.checkIn);
                    var alertTime = new Date(new Date(res.data.checkOut) - 5 * 60000);
                    var lock;
                    var locks = JSON.parse(localStorage.getItem('locks'));
                    if (locks === null || locks[res.data.client_id] === null || locks[res.data.client_id] === "") lock = res.data.client_id;
                    else lock = locks[res.data.client_id];
                    var obj = {
                        isLogged: true,
                        type: 'guest',
                        name: res.data.name,
                        id: guestID,
                        checkOut: guestTime,
                        checkIn: checkInTime,
                        imageUri: "img/profile-icon.png",
                        alertTime: alertTime,
                        bleId: res.data.bleid,
                        currentLock: res.data.client_id,
                        currentLockName: "Home",
                        lockType: 'BKW',
                        passcode: res.passcode,
                        mac: ""
                    }
                    console.log(obj);
                    var doorStatus = JSON.parse(localStorage.getItem("doorStatus"));
                    doorStatus[obj.currentLock] = "close";
                    localStorage.setItem("doorStatus", JSON.stringify(doorStatus));
                    if (Math.abs(timestamp - systemDate) > 900000) {
                        obj.isLogged = false;
                        localStorage.setItem('login', JSON.stringify(obj));
                        $ionicPopup.alert({
                            title: 'Caution',
                            content: '<center>The system date is not correct!!</center>'
                        });
                        return;
                    }
                    localStorage.setItem('login', JSON.stringify(obj));
                    console.log(obj)
                    $scope.loading.hide();
                    $ionicPopup.alert({
                        title: 'Proceed',
                        content: '<center>Welcome ' + res.data.name + '!!</center>'
                    }).then(function(response) {
                        console.log(response);
                        $state.go('ble');
                    });
                } else {
                    $scope.loading.hide();
                    $ionicPopup.alert({
                        content: '<center>Guest does not exist.</center>'
                    });
                }
            }, function(res) {
                console.log(res);
                $scope.loading.hide();
                tools.toast("No internet connection");
            });
        }
    };

    function authenticate(mac, id, productID) {
        var data = "wguestLogin " + id + " ";
        var startReceiving = false;
        connected = mac;
        $scope.userData = "";
        $scope.loading.show();
        ngBLE.connect(mac).then(null, function(err){
            $scope.connected = false;
            $scope.loading.hide();
            tools.hideLoad();
        }, function(res){
            console.log(res);
            if(res.msg == 'connected'){
                $scope.connected = true;
                ngBLE.discover(mac).then(function(res){
                    ngBLE.write(mac, data);
                    ngBLE.subscribe(mac).then(null, null, function(message){
                        if (message.substring(0, 12) === 'loginSuccess' || startReceiving === true) {
                            startReceiving = true;
                            $scope.userData += message;
                            console.log($scope.userData);
                            // loginSuccess 10:43:22/25:07:17/10:43:22/25:07:17 dataEnd
                            if ($scope.userData.indexOf('dataEnd') !== -1) {
                                startReceiving = false;
                                var words = $scope.userData.split(" ");
                                var timeData = words[1].split("/");
                                var checkInTime = tools.parse(timeData[0]+"/"+timeData[1]);
                                var guestTime = tools.parse(timeData[2]+"/"+timeData[3]);
                                var alertTime = new Date(guestTime.getTime() - 5 * 60000);
                                ngBLE.disconnect();
                                $scope.loading.hide();
                                $ionicPopup.prompt({
                                    title: 'Login Successfull',
                                    template: "What's your name?",
                                    inputPlaceholder: 'Vishal'
                                }).then(function(res) {
                                    if (res == "") {
                                        res = "Anonymous";
                                    }
                                    var loginObj=JSON.parse(localStorage.getItem('login'));
                                    var obj = {
                                        isLogged: true,
                                        type: 'guest',
                                        id: id,
                                        name: res,
                                        checkOut: guestTime,
                                        checkIn: checkInTime,
                                        imageUri: "img/profile-icon.png",
                                        alertTime: alertTime,
                                        bleId: mac,
                                        currentLock: productID,
                                        currentLockName: "Home",
                                        passcode:loginObj.passcode
                                    }
                                    console.log(obj);
                                    localStorage.setItem('login', JSON.stringify(obj));
                                    $state.go('ble', {}, {
                                        reload: true
                                    });
                                });
                                tools.hideLoad();
                            }
                        }
                        message = message.trim();
                        if (message === 'loginFail') {
                            $scope.loading.hide();
                            $ionicPopup.show({
                                title: "Error",
                                template: "Invalid ID, try again later.",
                                buttons: [{
                                    text: 'OK',
                                    type: 'button-positive'
                                }]
                            }).then(function(res) {
                                $state.go('guestLogin', {}, {
                                    reload: true
                                });
                            })
                        }
                    });
                }, function(err){
                    $scope.loading.hide();
                });
            }else{
                $scope.connected = false;
                $scope.loading.hide();
            }
        });
    }
    $scope.$on('$destroy', function() {
        ngBLE.disconnect();
        $scope.loading.hide();
    })
}).controller('homeCtrl', function($scope, tools, $ionicLoading, $ionicPopup, 
    $stateParams, $cordovaBluetoothLE, MQTT, $ionicHistory, $state, 
    $ionicPlatform, $ionicPopover, $ionicNavBarDelegate) {
    $ionicHistory.clearHistory();
    var client = mqtt.connect(mqttUrl);
    client.on('connect', function(){
        client.subscribe(loginObj.macId+"/"+"notify");
    });
    $scope.x = JSON.parse(window.localStorage.getItem('user'));
    $scope.data = {
        lockBool: false,
        backgroundColor: "",
        opacity: "0.3",
        title: "Internet"
    }
    var loginObj = JSON.parse(localStorage.getItem('login'));
    $scope.latch='Night Latch Of';
    if (loginObj.type == 'guest') {
        $state.go('ble', {
            reload: true
        });
    }
    if (loginObj.locks.length > 0) {
        console.log("Proceed");
    }else
        $state.go('locks');
    $scope.data.title = loginObj.currentLockName;
    $ionicPlatform.ready(function() {
        if (window.Connection) {
            if (navigator.connection.type == Connection.NONE) {
                $scope.data.opacity = '0.3';
                $ionicPopup.confirm({
                    title: "Internet Disconnected",
                    content: "The internet is disconnected on your device."
                });
            } else {
                $scope.data.opacity = "1";
            }
        }
    });
    $scope.lock = true;
    $scope.state = "";
    if ($scope.data.lockBool === true) {
        $scope.data.backgroundColor = "#4bd248";
        $scope.state = "UnLocked";
    }
    if ($scope.data.lockBool === false) {
        $scope.data.backgroundColor = "#6bb8e6";
        $scope.state = "Locked";
    }
    
    $scope.unlock = function() {
        if ($scope.latch == 'Night Latch Of' || $scope.latch1 == 'Night Latch Of') {
            var topic= loginObj.macId + '/lock';
            var payload= 'open';
            client.publish(topic, payload);
        } else if ($scope.latch == 'Night Latch On' || $scope.latch1 == 'Night Latch On') {
            $ionicPopup.alert({
                content: '<center>NightLatch is On! Can\'t Open the Door</center>'
            });
        }
    }
    $scope.refreshNow = function() {
        $ionicPlatform.ready(function() {
            if (window.Connection) {
                if (navigator.connection.type == Connection.NONE) {
                    $scope.data.opacity = '0.3';
                    $ionicPopup.confirm({
                        title: "Internet Disconnected",
                        content: "The internet is disconnected on your device."
                    })
                } else {
                    $scope.data.opacity = "";
                }
            }
        });
    }
    
    client.on('message', function(topic, payload){
        payload=String(payload);
        if(topic==='loginObj.macId+"/"+"notify"' && payload==='open'){
            $scope.data.lockBool = true;
            $scope.data.backgroundColor = "#4bd248";
            $scope.state = "UnLocked";
        }else if(topic==='loginObj.macId+"/"+"notify"' && payload==='on'){
            $scope.data.lockBool = false;
            $scope.data.backgroundColor = "#6bb8e6";
            $scope.state = "Locked";
        }
        if (!$scope.$$phase) {
            $scope.$apply();
        }
    });
    $scope.$on('$destroy', function(){
        client.end();
    });
}).controller('bleCtrl', function($http, $scope, $ionicPopup, $interval, guestTimeout, $ionicLoading, $ionicHistory, $ionicPlatform, $cordovaBluetoothLE, ngBLE, tools, $state) {
    tools.hideLoad();
    $ionicHistory.clearHistory();
    $scope.loading=$ionicLoading;
    $scope.state = "";
    console.log('bleCtrl');
    var loginObj = JSON.parse(localStorage.getItem('login'));
    var bleId = loginObj.bleId;
    $scope.data = {
        lockBool: false,
        alertTime: loginObj.alertTime,
        backgroundColor: "",
        opacity: ".3",
        enable: false,
        title: "BLE",
        opened: false
    }
    $scope.stop = function() {
        tools.hideLoad();
    }
    var timeout;

    if (loginObj.type == "guest" || loginObj.locks.length > 0) {
        $scope.data.title = loginObj.currentLockName;
        $scope.lockType = loginObj.lockType;
        $scope.data.lockBool = false;
        $scope.checkOut = new Date(loginObj.checkOut);
        $scope.checkIn = new Date(loginObj.checkIn);
        
        $scope.wifiBool = (loginObj.type == 'admin')?true:false;
        
        var connect = function(id) {
            $scope.data.opacity = "0.3";
            $scope.loading.show();
            
            ngBLE.connect(id).then(null, function(err){
                $scope.data.opacity = "0.3";
                $scope.connected = false;
                $scope.loading.hide();
                console.log(err);
            }, function(res){
                if(res.msg == 'connected'){
                    $scope.connected = true;
                    ngBLE.discover(id).then(function(res){
                        ngBLE.subscribe(id).then(null, null, function(success){
                            $scope.data.opacity = "1";
                            $scope.loading.hide();
                            if(success==='subscribed'){
                                return;
                            }
                            console.log(success);
                            success = success.trim();
                            if(success == 'subscribed'){
                                $scope.data.opacity = "1";
                                tools.hideLoad();
                            }
                            if (success === "open") {
                                if($scope.data.opened === true){
                                    open(loginObj);
                                    setTimeout(function() {
                                        if (loginObj.lockType !== "BKW") {
                                            close(loginObj);
                                        }
                                    }, 2000);
                                }
                            } else if (success === "off"||success === "on") {
                                close(loginObj);
                                $scope.data.opened = false;
                            } else if (success == "Latch is ON"){
                                tools.toast("Night latch is ON.");
                            }
                            if (success == 'Guest does not exist') {
                                loginObj.isLogged = false;
                                localStorage.setItem('login', JSON.stringify(loginObj));
                                $state.go('login');
                            }
                        });
                    }, function(err){
                        $scope.loading.hide();
                        $scope.data.opacity = "0.3";
                    });
                }
                else{
                    $scope.connected = false;
                    $scope.data.opacity = "0.3";
                    $scope.loading.hide();
                }
            });
        }
        $ionicPlatform.ready(function() {
            setTimeout(function() {
                connect(bleId);
            }, 500);
        });
        $scope.refreshNow = function() {
            connect(bleId);
        }
        var write = function(id) {
            var loginObj = JSON.parse(localStorage.getItem('login'));
            var writeString = "";
            if (loginObj.type === 'admin') {
                writeString = "aopen";
            }
            if (loginObj.type === 'guest') {
                writeString = 'o' + loginObj.id;
            }
            $scope.data.opened = true;
            ngBLE.write(id, writeString);
        }
        if ($scope.data.lockBool === true) {
            $scope.data.backgroundColor = "#4bd248";
            $scope.state = "UnLocked";
            // blePeripheral.initializePeripheral(bleId);
        }
        if ($scope.data.lockBool === false) {
            console.log("locked");
            $scope.data.backgroundColor = "#6bb8e6";
            $scope.state = "Locked";
        }

        function open(loginObj) {
            $scope.data.lockBool = true;
            $scope.data.backgroundColor = "#4bd248";
            $scope.state = "UnLocked";
        }

        function close(loginObj) {
            $scope.data.lockBool = false;
            $scope.data.backgroundColor = "#6bb8e6";
            $scope.state = "Locked";
        }
        
        var i = setInterval(function() {
            $scope.$apply();
            var loginObj = JSON.parse(localStorage.getItem('login'));
            $scope.lockType = loginObj.lockType;
            $scope.data.title = loginObj.currentLockName;
        }, 1000)
    
        $scope.unlock = function() {
            if (tools.isLoading === true) return;
            if ($scope.data.opacity === "1") 
                write(bleId);
            else {
                tools.toast("Not connected, refresh to connect.");
            }
        }
    }
    $scope.$on('$destroy', function() {
        clearInterval(i);
        if (timeout !== null && timeout !== undefined) clearTimeout(timeout);
        ngBLE.disconnect();
    });
}).controller('tabsCtrl', function($scope) {
    console.log('tabhsCtrl');
}).controller('inviteCtrl', function($scope, $state, $stateParams, $ionicHistory, tools) {
    tools.hideLoad();
    $scope.data = {
        name: "",
        cno: "",
        email: ""
    }
    if ($stateParams.edit == "true") {
        var editItem = localStorage.getItem('editItem');
        var obj = JSON.parse(localStorage.getItem('editItem'));
        $scope.data.name = obj.name;
        $scope.data.email = obj.email;
        $scope.data.cno = obj.cno;
    } else {
        $scope.data.name = "";
        $scope.data.cno = "";
        $scope.data.email = "";
    }
    $scope.next1 = function() {
        var data = {
            name: $scope.data.name,
            email: $scope.data.email,
            cno: $scope.data.cno
        };
        localStorage.setItem('invite', JSON.stringify(data));
        $state.go('add_Guest.permissions', {
            edit: $stateParams.edit
        });
    }
    $scope.form = function(form) {
        console.log(form);
    }
    $scope.myGoBack = function() {
        $ionicHistory.goBack();
    }
}).controller('permissionsCtrl', function($scope, $state, $ionicPlatform, $stateParams, $ionicPopup, $filter) {
    $scope.myGoBack = function() {
        $state.go('guests', {}, {
            reload: true
        });
    }
    var loginObj = JSON.parse(localStorage.getItem('login'));
    $scope.data = {
        checkIn: "",
        checkOut: "",
        startTime: "",
        endTime: "",
        notify: false,
        lockType: loginObj.lockType,
        dateInput: new Date(),
        time: new Date(),
        interval: false
    }
    var date1, date2;
    console.log($scope.data.lockType);
    if ($stateParams.edit == "true") {
        var obj = JSON.parse(localStorage.getItem('editItem'));
        console.log(obj);
        $scope.data.lockType = obj.lockType;
        $scope.data.checkIn = new Date(obj.checkIn);
        $scope.data.checkOut = new Date(obj.checkOut);
        var startInter = obj.startInter;
        startInter = startInter.split(':');
        $scope.data.startTime = new Date();
        $scope.data.startTime.setHours(startInter[0]);
        $scope.data.startTime.setMinutes(startInter[1]);
        var endInter = obj.endInter;
        endInter = endInter.split(':');
        $scope.data.endTime = new Date();
        $scope.data.endTime.setHours(endInter[0]);
        $scope.data.endTime.setMinutes(endInter[1]);
        $scope.data.notify = obj.notify;
        date1 = new Date(obj.checkIn);
        date2 = new Date(obj.checkOut);
        if (obj.startInter === '00:00') {
            $scope.data.interval = false;
        } else {
            $scope.data.interval = true;
        }
    }
    $ionicPlatform.ready(function() {
        $scope.data.lockType = loginObj.lockType;
    })
    $scope.date = function(string) {
        $scope.data.lockType = loginObj.lockType;
        try {
            var options = {
                date: new Date(),
                mode: 'datetime',
                androidTheme: plugins.datePicker.ANDROID_THEMES.THEME_DEVICE_DEFAULT_LIGHT
            }

            function onError(error) { // Android only
                console.log('Error: ' + error);
            }
            datePicker.show(options, function(date) {
                if (string === 'checkIn') {
                    $scope.data.checkIn = date;
                } else {
                    $scope.data.checkOut = date;
                }
            }, onError);
        } catch (e) {
            var today = new Date();
            var date = prompt("Please enter date.",
                today.getDate()+"-"+(today.getMonth()+1)+"-"+today.getFullYear());
            if(date){
                var dateSplit=date.split('-');
                var time = prompt("Please enter time.", 
                    today.getHours()+"-"+today.getMinutes()+"-"+today.getSeconds());
                var timeSplit=time.split('-');
                var finalDate=new Date(dateSplit[2],
                    dateSplit[1]-1,
                    dateSplit[0],
                    timeSplit[0],
                    timeSplit[1], 
                    timeSplit[2]);
                if (string === 'checkIn') {
                    $scope.data.checkIn = finalDate;
                } else {
                    $scope.data.checkOut = finalDate;
                }
            }
        }   
    }
    $scope.time = function(string) {
        if (string == 'startTime') {
            if ($scope.data.startTime == "") var date = new Date();
            else var date = $scope.data.startTime;
        } else {
            if ($scope.data.endTime == "") var date = new Date();
            else var date = $scope.data.endTime;
        }
        try {
            var options = {
                date: date,
                mode: 'time',
                androidTheme: plugins.datePicker.ANDROID_THEMES.THEME_DEVICE_DEFAULT_LIGHT
            }

            function onError(error) { // Android only
                console.log('Error: ' + error);
            }
            datePicker.show(options, function(time) {
                console.log(time);
                if (string === 'startTime') {
                    $scope.data.startTime = new Date(time);
                } else {
                    $scope.data.endTime = new Date(time);
                }
            }, onError);
        } catch (e) {}
    }
    $scope.next2 = function() {
        console.log($scope.data.startTime);
        console.log($scope.data.interval);
        if ($scope.data.checkIn == "" || $scope.data.checkOut == "") {
            $ionicPopup.alert({
                title: 'Incomplete data',
                template: '<center>Please fill out the missing fields.</center>'
            });
            return;
        }
        if ($scope.data.interval == true && ($scope.data.startTime == "" || $scope.data.endTime == "")) {
            $ionicPopup.alert({
                title: 'Incomplete data',
                template: '<center>Please fill out the missing fields.</center>'
            });
            return;
        } else if ($scope.data.interval == false) {
            var dateMidnight = new Date();
            dateMidnight.setHours(0);
            dateMidnight.setMinutes(0);
            $scope.data.startTime = dateMidnight;
            $scope.data.endTime = dateMidnight;
        }
        if ($scope.data.checkIn > $scope.data.checkOut || $scope.data.startTime > $scope.data.endTime) {
            $ionicPopup.alert({
                title: 'Date-time error',
                template: 'Start date or time cannot be greater than end date or time.'
            });
            return;
        }
        console.log($filter('date')($scope.data.startTime, 'HH:mm'));
        var data = {
            checkIn: $scope.data.checkIn,
            checkOut: $scope.data.checkOut,
            notify: $scope.data.notify,
            startTime: $filter('date')($scope.data.startTime, 'HH:mm'),
            endTime: $filter('date')($scope.data.endTime, 'HH:mm')
        };
        console.log(data);
        localStorage.setItem('permissions', JSON.stringify(data));
        $state.go('add_Guest.guestRole', {
            edit: $stateParams.edit
        });
    }
}).controller('guestRoleCtrl', function($scope, guestlogIn, $state, $stateParams, $ionicPopup, GuestList,
     $ionicLoading, $cordovaBluetoothLE, ngBLE, tools, http) {
    tools.hideLoad();
    var x = window.localStorage.getItem('user');
    x = JSON.parse(x);
    $scope.data = {
        keypad: false
    }
    $scope.padkey = 0000;
    var id = Math.floor(Math.random() * 8999 + 1000); //for Guestlogin
    if ($stateParams.edit == "true") {
        $scope.edit = "Update";
        var obj = JSON.parse(localStorage.getItem('editItem'));
        $scope.data.keypad = obj.keypad;
    } //assign edit
    else {
        $scope.edit = "Add Guest!";
        $scope.data.keypad = false;
    }
    $scope.loading=$ionicLoading;
    var admin = false;
    var invite = JSON.parse(localStorage.getItem('invite'));
    var permissions = JSON.parse(localStorage.getItem('permissions'));
    var loginObj = JSON.parse(localStorage.getItem('login'));
    $scope.lockType = loginObj.lockType;
    $scope.myGoBack = function() {
        $state.go('guests', {}, {
            reload: true
        });
    }
    
    $scope.addGuest = function() {
        console.log($scope.padkey);
        if ($stateParams.edit == 'true') {
            id = obj.keyId;
        }
        confirmAdd = {
            adminName: loginObj.adminName,
            client_id: loginObj.currentLock,
            keyId: id,
            name: invite.name,
            email: invite.email,
            cno: invite.cno,
            bleid: loginObj.bleId,
            checkIn: permissions.checkIn,
            checkOut: permissions.checkOut,
            notify: permissions.notify,
            keypad: $scope.data.keypad
        }
        $ionicPopup.confirm({
            title: "Are you sure?",
            template: "<b>Name:</b> " + confirmAdd.name + "<br><b>Email:</b> " + confirmAdd.email + "<br><b>Contact No:</b> " + confirmAdd.cno + "<br><b>Start Time: </b>" + new Date(confirmAdd.checkIn).toDateString() + "<br><b>End Time:</b> " + new Date(confirmAdd.checkOut).toDateString()
        }).then(function(res) {
            var doc;
            if (res) {
                $scope.loading.show();
                //======Guest Update=========
                if ($stateParams.edit == 'true') {
                    var c = JSON.parse(localStorage.getItem('editItem'));
                    doc = {
                        _id: c._id,
                        _rev: c._rev,
                        adminName: loginObj.adminName,
                        client_id: loginObj.currentLock,
                        keyId: id,
                        name: invite.name,
                        email: invite.email,
                        cno: invite.cno,
                        bleid: loginObj.bleId,
                        checkIn: permissions.checkIn,
                        checkOut: permissions.checkOut,
                        notify: permissions.notify,
                        keypad: $scope.data.keypad,
                        enable: true,
                        startInter: permissions.startTime,
                        endInter: permissions.endTime
                    }
                    console.log(doc);
                    guestlogIn.update(doc, function(r) {
                        $scope.loading.hide();
                        doc.global = true;
                        db.put(doc, function(error, response) {
                            if (error) {
                                tools.toast("Database error");
                            }
                            if (response) {
                                guestAddPopupMsg(doc);
                            }
                        });
                    }, function(r) {
                        doc.global = false;
                        db.put(doc, function(error, response) {
                            $scope.loading.hide();
                            if (error) {
                                tools.toast("Database error");
                            }
                            if (response) {
                                guestAddPopupMsg(doc);
                            }
                        });
                    });
                }
                //=========Guest Add=========
                else {
                    doc = {
                        keyId: id,
                        adminName: loginObj.adminName,
                        name: invite.name,
                        client_id: loginObj.currentLock,
                        email: invite.email,
                        cno: invite.cno,
                        checkIn: permissions.checkIn,
                        checkOut: permissions.checkOut,
                        notify: permissions.notify,
                        bleid: loginObj.bleId,
                        keypad: $scope.data.keypad,
                        enable: true,
                        startInter: permissions.startTime,
                        endInter: permissions.endTime
                    }
                    console.log(doc);
                    http.addGuest(doc).then(function(res) {
                        doc.global = true;
                        db.post(doc, function(error, response) {
                            if (response) {
                                console.log('posting ' + response);
                                guestAddPopupMsg(doc);
                            }
                        });
                    }, function(err) {
                        db.post(doc, function(error, response) {
                            if (response) {
                                console.log('posting ' + response);
                                guestAddPopupMsg(doc);
                            }
                        });
                    });
                }
            }
        });
    }

    function guestAddPopupMsg(doc) {
        var popupMsg = ""; 
        if ($stateParams.edit == 'true') {
            popupMsg = "updated";
        } else {
            popupMsg = "added";
        }
        console.log('keyId,Keypad ' + doc.keyId, doc.keypad);
        if (!(id == 0)) //For loginId
        {
            $ionicPopup.alert({
                content: '<center>Guest ' + popupMsg + ' with Id: ' + id + '</center>'
            }).then(function(res) {
                $state.go('guests', {
                    reload: true
                });
            });
        } else {
            $ionicPopup.alert({
                content: '<center>Guest ' + popupMsg + ' with Id: ' + id + '</center>'
            }).then(function(res) {
                $state.go('guests', {
                    reload: true
                });
            });
        }
    }
    $scope.$on("$destroy", function() {
        $scope.loading.hide();
    });
}).controller('BLEGuestAddCtrl', function($scope, $ionicPopup, $stateParams, tools, $ionicLoading, ngBLE, $state) {
    var id = Math.floor(Math.random() * 8999 + 1000);
    var loginObj = JSON.parse(localStorage.getItem('login'));
    $scope.lockType = loginObj.lockType;
    $scope.loading=$ionicLoading;
    $scope.data = {
        checkIn: new Date(),
        checkOut: new Date(),
        keypad: false,
        name: "",
        title: "Add guest"
    }
    var editItem;
    $scope.allMacs = allMacs;
    console.log($stateParams.edit);
    if ($stateParams.edit === "true") {
        $scope.data.title = "Edit";
        editItem = JSON.parse(localStorage.getItem('editItem'));
        console.log(editItem);
        id = editItem.keyId;
        $scope.data.checkIn = editItem.checkIn;
        $scope.data.checkOut = editItem.checkOut;
        $scope.data.keypad = editItem.keypad;
        $scope.data.name = editItem.name;
    }
    $scope.date = function(string) {
        console.log(string);
        var options = {
            date: new Date(),
            mode: 'datetime',
            androidTheme: plugins.datePicker.ANDROID_THEMES.THEME_DEVICE_DEFAULT_LIGHT
        }

        function onError(error) { // Android only
            console.log('Error: ' + error);
        }
        datePicker.show(options, function(date) {
            if (string === 'checkIn') {
                $scope.data.checkIn = date;
            } else {
                $scope.data.checkOut = date;
            }
        }, onError);
    }
    $scope.add = function() {
        if ($scope.data.checkIn > $scope.data.checkOut) {
            $ionicPopup.alert({
                title: 'Date error',
                template: 'Start date cannot be greater than end date'
            });
            return;
        }
        var confirmAdd = {
            adminName: loginObj.adminName,
            client_id: loginObj.currentLock,
            keyId: id,
            checkIn: $scope.data.checkIn,
            checkOut: $scope.data.checkOut,
            name: $scope.data.name,
            enable: true
        }
        $ionicPopup.show({
            template: "<b>Name </b>" + $scope.data.name + "<br><b>ID: </b>" + id + "<br>" + "<b>Start Time: </b>" + new Date(confirmAdd.checkIn).toDateString() + "<br><b>End Time:</b> " + new Date(confirmAdd.checkOut).toDateString(),
            title: "Are you sure?",
            scope: $scope,
            buttons: [{
                text: "Cancel"
            }, {
                text: "OK",
                onTap: function(e) {
                    add(confirmAdd);
                }
            }]
        });
    }
    function add(confirmAdd){
        $scope.loading.show();
        /*----------------------------------update---------------------------------*/
        if ($stateParams.edit == 'true') {
            if (loginObj.lockType === 'B') {
                var dataString = "wdatamodify " + confirmAdd.keyId + "/";
            } else {
                var keypad = "B";
                confirmAdd.keypad=$scope.data.keypad;
                if ($scope.data.keypad===true) keypad="A";
                var dataString = "wdatamodify " + confirmAdd.keyId + "/" + keypad + "/";
            }
            dataString += tools.toBleDateFormat(confirmAdd.checkIn) + "/";
            dataString += tools.toBleDateFormat(confirmAdd.checkOut) + " ";
            console.log(dataString);
            var bleId = loginObj.bleId;
            console.log(bleId);
            ngBLE.connect(bleId).then(null, function(err){
                $scope.connected = false;
                confirmAdd.global = false;
                confirmAdd._id = editItem._id;
                confirmAdd._rev = editItem._rev;
                var toEdit = JSON.parse(localStorage.getItem('toEdit'));
                if (toEdit == undefined || toEdit == null || toEdit.items == null) {
                    toEdit = {
                        items: []
                    }
                }
                var obj = {
                    dataString: dataString,
                    lock: loginObj.currentLock
                }
                toEdit.items.push(obj);
                localStorage.setItem('toEdit', JSON.stringify(toEdit));
                db.post(confirmAdd, function(error, response) {
                    console.log(error, response);
                    $ionicPopup.show({
                        title: "Guest update",
                        subTitle: "Lock is not in range, guest will be updated later.",
                        buttons: [{
                            text: 'OK'
                        }]
                    }).then(function(res) {
                        $state.go('guests', {}, {
                            reload: true
                        });
                    });
                });
                $scope.loading.hide();
            }, function(res){
                if(res.msg == 'connected'){
                    $scope.connected = true;
                    ngBLE.discover(bleId).then(function(res){
                        ngBLE.subscribe(bleId).then(null, null, function(success){
                            if(success==='subscribed'){
                                ngBLE.write(bleId, dataString);
                                return;
                            }
                            success = success.trim();
                            if (success === 'modifydone') {
                                confirmAdd.global = true;
                                confirmAdd._id = editItem._id;
                                confirmAdd._rev = editItem._rev;
                                db.post(confirmAdd, function(error, response) {
                                    if(error){
                                        tools.toast("Database Error");
                                        return;
                                    }
                                    $ionicPopup.show({
                                        title: "Guest updated successfully.",
                                        buttons: [{
                                            text: 'OK'
                                        }]
                                    }).then(function(res) {
                                        $state.go('guests', {}, {
                                            reload: true
                                        });
                                    })
                                    $scope.loading.hide();
                                });
                            }
                            if (success == 'modifyfail') {
                                $scope.loading.hide();
                                tools.toast("Guest does not exists, try again.");
                                ngBLE.disconnect();
                            }
                        });
                    }, function(err){
                        $scope.loading.hide();
                    });
                }
                else{
                    $scope.loading.hide();
                }
            });
        }
        /*-----------------------------------add-----------------------------------*/
        else {
            if (loginObj.lockType === 'B') {
                var dataString = "wguestadd " + confirmAdd.keyId + "/";
            } else {
                var keypad = "B";
                confirmAdd.keypad = $scope.data.keypad;
                if ($scope.data.keypad === true) keypad = "A";
                var dataString = "wguestadd " + confirmAdd.keyId + "/" + keypad + "/";
            }
            dataString += tools.toBleDateFormat(confirmAdd.checkIn) + "/";
            dataString += tools.toBleDateFormat(confirmAdd.checkOut) + " ";
            console.log(dataString);
            var bleId = loginObj.bleId;
            console.log(bleId);
            ngBLE.connect(bleId).then(null, function(err){
                $scope.connected = false;
                confirmAdd.global = false;
                var toAdd = JSON.parse(localStorage.getItem('toAdd'));
                if (toAdd == undefined || toAdd == null || toAdd.items == null) {
                    toAdd = {
                        items: []
                    }
                }
                var obj = {
                    dataString: dataString,
                    lock: loginObj.currentLock
                }
                toAdd.items.push(obj);
                localStorage.setItem('toAdd', JSON.stringify(toAdd));
                db.post(confirmAdd, function(error, response) {
                    if(error){
                        tools.toast("Database Error");
                        return;
                    }
                    $ionicPopup.show({
                        title: "Guest add",
                        subTitle: "Lock is not in range, guest will be added later.",
                        buttons: [{
                            text: 'OK'
                        }]
                    }).then(function(res) {
                        $state.go('guests', {}, {
                            reload: true
                        });
                        ngBLE.disconnect();
                    })
                    $scope.loading.hide();
                });
            }, function(res){
                if(res.msg == 'connected'){
                    $scope.connected = true;
                    ngBLE.discover(bleId).then(function(res){
                        ngBLE.subscribe(bleId).then(null, null, function(success){
                            console.log(success);
                            if(success==='subscribed'){
                                // ngBLE.write(bleId, "hitron123/");
                                ngBLE.write(bleId, dataString);
                                return;
                            }
                            success = success.trim();
                            if (success === 'guestaddsuccess') {
                                confirmAdd.global = true;
                                db.post(confirmAdd, function(error, response) {
                                    console.log(error, response);
                                    $ionicPopup.show({
                                        title: "Guest added successfully.",
                                        buttons: [{
                                            text: 'OK'
                                        }]
                                    }).then(function(res) {
                                        $state.go('guests', {}, {
                                            reload: true
                                        });
                                        ngBLE.disconnect();
                                    })
                                    $scope.loading.hide();
                                });
                            }
                            if (success === 'guestaddfail') {
                                $scope.loading.hide();
                                tools.toast("Failed to add guest, try again.");
                                ngBLE.disconnect();
                            }
                        });
                    }, function(err){
                        $scope.loading.hide();
                    });
                }
                else{
                    $scope.connected = false;
                    $scope.loading.hide();
                }
            });
        }
    }
    $scope.$on("$destroy", function() {
        ngBLE.disconnect();
        $scope.loading.hide();
    });
}).controller('guestActivityCtrl', function($scope, $filter, $stateParams, $ionicSideMenuDelegate, $http) {
    tools.hideLoad();
    var item = JSON.parse($stateParams.guest);
    var startTime = new Date(item.checkIn);
    var endTime = new Date(item.checkOut).getTime();
    var current = new Date().getTime();
    $ionicSideMenuDelegate.canDragContent(false);
    $scope.days = ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"];
    console.log(startTime.toString());
    console.log(endTime.toString());
    var notifications = JSON.parse(localStorage.getItem('notifications')).array;
    $scope.activities = [];
    $scope.allActivities = [];
    console.log(notifications);
    for (var i = 0; i < notifications.length; i++) {
        if (notifications[i].id == item.keyId) {
            $scope.allActivities.push(notifications[i]);
        }
    }
    $scope.activities = $scope.allActivities;
    $("#activityRange").ionRangeSlider({
        type: "double",
        min: (startTime.valueOf()),
        max: (endTime.valueOf()),
        grid: true,
        grid_num: 2,
        prettify: function(num) {
            date = new Date(num);
            var string = $filter('date')(date, 'd MMM yy');
            return string;
        },
        onFinish: function(data) {
            $scope.activities = [];
            var smallDate = new Date(data.from).getTime();
            var largeDate = new Date(data.to).getTime()
            for (var i = 0; i < $scope.allActivities.length; i++) {
                var comD = $scope.allActivities[i].date;
                if (comD > smallDate && comD < largeDate) {
                    $scope.activities.push($scope.allActivities[i]);
                }
            }
        }
    });
}).controller('guestsCtrl', function(http, $scope, $stateParams, guestlogIn, $ionicPlatform, 
    GuestList, $state, guestTimeout, $ionicHistory, $ionicPopup, GuestList,
    $ionicLoading, tools, ngBLE, $filter, $ionicPopover) {
    tools.hideLoad();
    $ionicHistory.clearHistory();
    var myTimeout;
    var x = window.localStorage.getItem('login');
    x = JSON.parse(x);
    var bleId = x.bleId;
    $scope.lockType = x.lockType;
    $scope.loginObj = x;
    $scope.list = [];
    var globalData = [];
    var toPouch = [],
        toServer = [];
    $scope.logs = [];
    $scope.loading=$ionicLoading;
    $scope.dataLogDialog = function(keyId, name, item) {
        $state.go('guestActivity', {
            guest: JSON.stringify(item)
        });
    }
    $ionicPopover.fromTemplateUrl('my-popover.html', {
        scope: $scope
    }).then(function(popover) {
        $scope.popover = popover;
    });
    $scope.openPopover = function(guest, index, event) {
        if (guest.enable !== true) return;
        $scope.optionsFor = guest;
        $scope.optionsIndex = index;
        $scope.popover.show(event);
    }
    $scope.closePopover = function() {
        if ($scope.popover !== null) {
            $scope.popover.hide();
        }
        return true;
    }
    $scope.details = function(guest, index) {
        var timeRemaining = guest.timeRemaining.days + ":" + guest.timeRemaining.hours + ":" + guest.timeRemaining.minutes + ":" + guest.timeRemaining.seconds;
        var alertTimeRemaining = guest.alertTimeRemaining.days + ":" + guest.alertTimeRemaining.hours + ":" + guest.alertTimeRemaining.minutes + ":" + guest.alertTimeRemaining.seconds;
        if (x.lockType == 'BKW') {
            if (guest.keypad !== undefined && guest.keypad === true) {
                var keypad = "<br>Keypad ID: " + guest.keypad;
            } else {
                var keypad = "<br>Keypad: Disabled";
            }
            var keyId = "bkw" + guest.keyId;
            var template = "Name: " + guest.name + "<br>Key ID: " + keyId + keypad + "<br>Time Remaining: " + timeRemaining + "<br>Alert at: " + alertTimeRemaining + "<br>Email: " + guest.email + "<br>Contact No.: " + guest.cno + "<br>Notifications: " + guest.notify;
        } else {
            if (guest.keypad !== undefined && guest.keypad === true) {
                var keypad = "<br>Keypad ID: " + guest.keyId;
            } else {
                var keypad = "<br>Keypad: Disabled";
            }
            var keyId = x.currentLock + guest.keyId;
            var template = "Name: " + guest.name + "<br>Key ID: " + keyId + keypad + "<br>Time Remaining: " + timeRemaining + "<br>Alert at: " + alertTimeRemaining;
        }
        console.log(template);
        $ionicPopup.show({
            template: template,
            title: "Details",
            scope: $scope,
            buttons: [{
                text: 'Close',
                type: "button-balanced"
            }]
        });
    }
    $scope.loading=$ionicLoading;
    $ionicPlatform.ready(function() {
        initialize(); 
    });
    function initialize(){
        $scope.loading.show();
        db.allDocs({
            include_docs: true
        }, function(error, response) {
            $scope.list = [];
            console.log(response);
            var i;
            for (i = 0; i < response.total_rows; i++) {
                var doc = response.rows[i].doc;
                if (doc.adminName == x.adminName && doc.client_id == x.currentLock) {
                    if (doc.alertTime == null || doc.alertTime == "") doc.alertTime = new Date(new Date(doc.checkOut) - 5 * 60000);
                    doc.opacity = "0.5";
                    if (doc.global != null) {
                        if (doc.global == true) doc.opacity = "1";
                    }
                    var date = new Date(doc.checkOut);
                    var date1 = new Date();
                    if (date1 < date) {
                        $scope.list.push(doc);
                    } else {
                        if (x.lockType !== 'BKW') {
                            var toDelete = JSON.parse(localStorage.getItem("toDelete"));
                            if (toDelete === null || toDelete === undefined) {
                                toDelete = {
                                    items: []
                                };
                            }
                            var obj = {
                                keyId: doc.keyId,
                                lock: x.currentLock
                            }
                            toDelete.items.push(obj);
                            localStorage.setItem("toDelete", JSON.stringify(toDelete));
                        }
                        db.remove(doc._id, doc._rev, function(error, response) {
                            if (error) console.log(error);
                            if (response) {
                                console.log(response);
                            }
                        });
                    }
                }
            }
            console.log($scope.list);
        });
        $scope.loading.hide();
    }
    $scope.$on("$destroy", function() {
        ngBLE.disconnect();
        if ($scope.popover !== null) {
            $scope.popover.remove();
        }
    });

    function parse(data) {
        // BLE6813/14:29:18/26:7:17
        var x = JSON.parse(localStorage.getItem('login'));
        var words = data.split(" ");
        db.allDocs({
            include_docs: true
        }, function(err, response) {
            console.log(err, response);
            if (response) {
                console.log(words);
                for (var i = 1; i < words.length - 1 || i == 1; i++) {
                    var data=words[i].split('/');
                    var via= data[0].substring(0,3);
                    var id = data[0].substring(3,7);
                    var name = undefined;
                    var found=false;
                    for (var j = 0; j < response.total_rows; j++) {
                        var doc = response.rows[j].doc;
                        if (doc.keyId == id) {
                            name = doc.name;
                            found=true;
                            break;
                        }
                    }
                    if (found === false) continue;
                    var date = tools.parse(data[1]+"/"+data[2]);
                    var data = {
                        msg: name + " opened the door via "+((via==='BLE')?'BLE.':'keypad.'),
                        date: date.getTime(),
                        day: date.getDay(),
                        lock: x.currentLock,
                        id: id
                    };
                    console.log(data);
                    var notifications = JSON.parse(localStorage.getItem('notifications'));
                    if (notifications != null) {
                        var array = notifications.array;
                    }
                    if (notifications == null) {
                        var array = [];
                        array.push(data)
                    }
                    array.push(data)
                    json = {
                        array: array
                    }
                    localStorage.setItem('notifications', JSON.stringify(json));
                }
                $ionicPopup.alert({
                    title: "Message",
                    template: "<center>Sync complete.</center>"
                });
            }
        })
    }
    $scope.sync = function() {
        var toServer = [];
        var toPouch = [];
        var toSync = [];
        var indices = [];
        var toAdd = JSON.parse(localStorage.getItem("toAdd"));
        if (toAdd == null) {
            toAdd = {
                items: []
            }
        }
        for (var i = 0; i < toAdd.items.length; i++) {
            if (toAdd.items[i].lock === x.currentLock) {
                var obj = {
                    dataString: toAdd.items[i].dataString
                }
                for (j = 0; j < $scope.list.length; j++) {
                    var words = toAdd.items[i].dataString.split(" ");
                    var tokens = words[1].split(',');
                    var id = tokens[0];
                    if ($scope.list[j].keyId == id) {
                        indices.push({
                            i: j,
                            delete: false
                        });
                        break;
                    }
                }
                toSync.push(obj);
            }
        }
        var toEdit = JSON.parse(localStorage.getItem("toEdit"));
        if (toEdit == null) {
            toEdit = {
                items: []
            }
        }
        for (var i = 0; i < toEdit.items.length; i++) {
            if (toEdit.items[i].lock === x.currentLock) {
                var obj = {
                    dataString: toEdit.items[i].dataString
                }
                for (j = 0; j < $scope.list.length; j++) {
                    var words = toEdit.items[i].dataString.split(" ");
                    var tokens = words[1].split(',');
                    var id = tokens[0];
                    if ($scope.list[j].keyId == id) {
                        indices.push({
                            i: j,
                            delete: false
                        });
                        break;
                    }
                }
                toSync.push(obj);
            }
        }
        var toDelete = JSON.parse(localStorage.getItem("toDelete"));
        if (toDelete == null) {
            toDelete = {
                items: []
            }
        }
        for (var i = 0; i < toDelete.items.length; i++) {
            if (toDelete.items[i].lock === x.currentLock) {
                var dataString = "wdelete " + toDelete.items[i].keyId + " ";
                var obj = {
                    dataString: dataString
                }
                for (j = 0; j < $scope.list.length; j++) {
                    if ($scope.list[j].keyId == toDelete.items[i].keyId) {
                        indices.push({
                            i: j,
                            delete: true
                        });
                        break;
                    }
                }
                toSync.push(obj);
            }
        }
        for(var i=0;i<toSync.length;i++){
            console.log(toSync[i].dataString);
        }
        var ok = true;
        if (x.lockType !== "BKW") {
            $ionicPopup.show({
                template: "<center>Stay in range of the lock to connect.</center>",
                title: "Refresh",
                scope: $scope,
                buttons: [{
                    text: "Cancel"
                }, {
                    text: "Refresh",
                    type: "button-balanced",
                    onTap: function(e) {
                        $scope.loading.show();
                        localStorage.setItem("index", 0);
                        if (toSync.length === 0) {
                            var startReceiving = false;
                            var data = "";
                            ngBLE.connect(x.bleId).then(null, function(err){
                                console.log(err);
                                $scope.connected=false;
                                $ionicPopup.alert({
                                    title: "Error",
                                    template: "<center>Sync failed.</center>"
                                });
                                $scope.loading.hide();
                            }, function(res){
                                console.log(res);
                                if(res.msg == 'connected'){
                                    $scope.connected = true;
                                    ngBLE.discover(x.bleId).then(function(res){
                                        ngBLE.subscribe(x.bleId).then(null, null, function(success){
                                            if(success==='subscribed'){
                                                // ngBLE.write(x.bleId, "hitron123/");
                                                ngBLE.write(x.bleId, "wdtalogfull  ");
                                                return;
                                            }
                                            if (success.indexOf('logstart') !== -1 || startReceiving === true) {
                                                startReceiving = true;
                                                data += success;
                                                console.log(data);
                                                if (data.indexOf('logend') !== -1) {
                                                    startReceiving = false;
                                                    parse(data);
                                                    for(var z=0;z<x.locks.length;z++){
                                                        if(x.locks[z].client_id===x.currentLock){
                                                            var adminKeypad=x.locks[z].adminKeypad;
                                                            ngBLE.write(x.bleId, 'wadkey ' + adminKeypad + ' ')
                                                            .then(function(){
                                                                ngBLE.disconnect();
                                                                $scope.loading.hide();
                                                            });
                                                            break;
                                                        }
                                                    }
                                                            
                                                }
                                            }
                                        });
                                    }, function(err){
                                        $scope.loading.hide();
                                    });
                                }
                                else{
                                    $scope.connected = false;
                                    $scope.loading.hide();
                                }
                            });
                            return;
                        }
                        ngBLE.connect(x.bleId).then(null, function(err){
                            console.log(err);
                            $scope.connected = false;
                            $ionicPopup.alert({
                                title: "Error",
                                template: "<center>Sync failed.</center>"
                            });
                            $scope.loading.hide();
                        }, function(res){
                            console.log(res);
                            if(res.msg == 'connected'){
                                $scope.connected = true;
                                ngBLE.discover(x.bleId).then(function(res){
                                    ngBLE.subscribe(x.bleId).then(null, null, function(success){
                                        if(success==='subscribed'){
                                            // ngBLE.write(x.bleId, "hitron123/");
                                            ngBLE.write(x.bleId, toSync[0].dataString);
                                            return;
                                        }
                                        clearTimeout(myTimeout);
                                        var rightOne = false;
                                        console.log(success);
                                        if (success.indexOf("guestaddsuccess") !== -1 || success.indexOf("guestaddfail") !== -1) {
                                            rightOne = true;
                                        }
                                        if (success.indexOf("deleted") !== -1 || success.indexOf("userid not present") !== -1) {
                                            rightOne = true;
                                        }
                                        if (success.indexOf("modifydone") !== -1 || success.indexOf("modifyfail") !== -1) {
                                            rightOne = true;
                                        }
                                        if (rightOne == true) {
                                            var i = Number(localStorage.getItem("index")) + 1;
                                            if (i == toSync.length) {
                                                for (var j = 0; j < $scope.list.length; j++) {
                                                    $scope.list[j].global = true;
                                                    $scope.list[j].opacity = "1";
                                                }
                                                localStorage.setItem('dbIndex', 0);
                                                for (var j = 0; j < indices.length; j++) {
                                                    if (indices[j].delete == true) {
                                                        console.log("going to delete");
                                                        db.remove($scope.list[indices[j].i]._id, $scope.list[indices[j].i]._rev, function(err, res) {
                                                            console.log(err, res);
                                                            var j = Number(localStorage.getItem("dbIndex"));
                                                            if (res) {
                                                                $scope.list.splice(indices[j].i, 1);
                                                            }
                                                            if (j == indices.length - 1) {
                                                                console.log("db updated");
                                                                db.allDocs({
                                                                    include_docs: true
                                                                }, function(error, response) {
                                                                    for (var k = 0; k < response.total_rows; k++) {
                                                                        var doc = response.rows[k].doc;
                                                                        if (doc.adminName === x.adminName) {
                                                                            for (var m = 0; m < $scope.list.length; m++) {
                                                                                if (doc.keyId == $scope.list[m].keyId) {
                                                                                    $scope.list[m]._id = doc._id;
                                                                                    $scope.list[m]._rev = doc._rev;
                                                                                    console.log($scope.list[m].keyId + " refreshed");
                                                                                    break;
                                                                                }
                                                                            }
                                                                        }
                                                                    }
                                                                });
                                                            }
                                                            localStorage.setItem('dbIndex', j + 1);
                                                        })
                                                    } else {
                                                        db.put($scope.list[indices[j].i], function(error, response) {
                                                            console.log(error, response);
                                                            var j = Number(localStorage.getItem("dbIndex"));
                                                            if (j == indices.length - 1) {
                                                                console.log("db updated");
                                                                db.allDocs({
                                                                    include_docs: true
                                                                }, function(error, response) {
                                                                    for (var k = 0; k < response.total_rows; k++) {
                                                                        var doc = response.rows[k].doc;
                                                                        if (doc.adminName === x.adminName) {
                                                                            for (var m = 0; m < $scope.list.length; m++) {
                                                                                if (doc.keyId == $scope.list[m].keyId) {
                                                                                    $scope.list[m]._id = doc._id;
                                                                                    $scope.list[m]._rev = doc._rev;
                                                                                    console.log($scope.list[m].keyId + " refreshed");
                                                                                    break;
                                                                                }
                                                                            }
                                                                        }
                                                                    }
                                                                });
                                                            }
                                                            localStorage.setItem('dbIndex', j + 1);
                                                        });
                                                    }
                                                }
                                                var toDelete = {
                                                    items: []
                                                };
                                                localStorage.setItem("toDelete", JSON.stringify(toDelete));
                                                var toEdit = {
                                                    items: []
                                                };
                                                localStorage.setItem("toEdit", JSON.stringify(toEdit));
                                                var toAdd = {
                                                    items: []
                                                };
                                                localStorage.setItem("toAdd", JSON.stringify(toAdd));
                                                ngBLE.write(x.bleId, "wdtalogfull  ");
                                                return;
                                            }
                                            console.log(toSync[i].dataString);
                                            ngBLE.write(x.bleId,toSync[i].dataString);
                                            localStorage.setItem("index", i);
                                        }
                                        console.log(startReceiving, data);
                                        if (success.indexOf('logstart') !== -1 || startReceiving === true) {
                                            startReceiving = true;
                                            data += success;
                                            console.log(data);
                                            if (data.indexOf('logend') !== -1) {
                                                startReceiving = false;
                                                parse(data);
                                                for(var z=0;z<x.locks.length;z++){
                                                    if(x.locks[z].client_id===x.currentLock){
                                                        var adminKeypad=x.locks[z].adminKeypad;
                                                        ngBLE.write(x.bleId, 'wadkey ' + adminKeypad + ' ')
                                                        .then(function(){
                                                            ngBLE.disconnect();
                                                            $scope.loading.hide();
                                                        });
                                                        break;
                                                    }
                                                }
                                            }
                                        }
                                    });
                                }, function(err){
                                    $scope.loading.hide();
                                });
                            }
                            else{
                                $scope.connected = false;
                            }
                        });
                    }
                }]
            });
            return;
        }
        $scope.loading.show();
        var loginObj = JSON.parse(localStorage.getItem('login'));
        var update = [];
        for(var z=0;z<$scope.list.length;z++){
            var currentDate=new Date();
            var dateOfDoc=new Date($scope.list[z].checkOut);
            console.log(currentDate,dateOfDoc)
            if(currentDate.getTime()>dateOfDoc.getTime()){
                $scope.list.splice(z,1);
                z--;
            }
        }
        http.findGuests({
            email: loginObj.adminName,
            client_id: loginObj.currentLock
        }).then(function(res) {
            var ids="";
            for(var i=0;i<res.length;i++){
                ids+=res[i].keyId;
            }
            console.log(ids);
            globalData = res;
            if (res == null) {
                return;
            }
            for (var i = 0; i < res.length; i++) {
                var ok = false;
                for (var j = 0; j < $scope.list.length; j++) {
                    if ($scope.list[j].keyId == res[i].keyId) {
                        ok = true;
                        var id = $scope.list[j]._id;
                        var rev = $scope.list[j]._rev;
                        $scope.list[j] = res[i];
                        $scope.list[j]._id = id;
                        $scope.list[j]._rev = rev;
                        delete $scope.list[j].__v;
                        if ($scope.list[j].global == null || $scope.list[j].global == false) {
                            $scope.list[j].global = true;
                        }
                        update.push($scope.list[j]);
                        break;
                    } else {
                        ok = false;
                    }
                }
                if (ok == false) {
                    for (var k = 0; k < toPouch.length; k++) {
                        if (res[i].keyId == toPouch[k].keyId) {
                            ok = true;
                            break;
                        }
                    }
                    if (ok == false) {
                        console.log("false");
                        var date = new Date();
                        var date1 = new Date(res[i].checkOut);
                        if (date1 > date) {
                            var doc = {
                                keyId: res[i].keyId,
                                adminName: res[i].adminName,
                                client_id: res[i].client_id,
                                name: res[i].name,
                                email: res[i].email,
                                cno: res[i].cno,
                                checkIn: res[i].checkIn,
                                checkOut: res[i].checkOut,
                                notify: res[i].notify,
                                admin: res[i].admin,
                                keypad: res[i].keypad,
                                global: true,
                                alertTime: new Date(new Date(res[i].checkOut) - 5 * 60000),
                                bleid: res[i].bleid,
                                enable: res[i].enable,
                                startInter: res[i].startInter,
                                endInter: res[i].endInter
                            }
                            toPouch.push(doc);
                        } else {
                            try {
                                console.log("Deleting guest record from server.");
                                http.deleteGuest({
                                    keyId: res[i].keyId
                                });
                            } catch (e) {
                                console.log(e);
                            }
                        }
                    }
                }
            }
            for (var i = 0; i < $scope.list.length; i++) {
                var ok = false;
                for (var j = 0; j < globalData.length; j++) {
                    if ($scope.list[i].keyId == res[j].keyId) {
                        ok = true;
                        $scope.list[i].opacity = "1";
                        break;
                    }
                }
                if (ok == false) {
                    console.log("item to be sent: " + $scope.list[i].keyId);
                    var doc = $scope.list[i];
                    $scope.list[i].opacity = "1";
                    var dateOfDoc=new Date(doc.checkOut);
                    var currentDate=new Date();
                    console.log(dateOfDoc.getTime(),currentDate.getTime())
                    if(dateOfDoc.getTime()>currentDate.getTime()){
                        toServer.push(doc);
                    }
                }
            }
            for (var i = 0; i < toPouch.length; i++) {
                var doc = toPouch[i];
                db.post(doc, function(err, response) {
                    if (err) console.log(err);
                    if (response && response.ok) {;
                        console.log(response);
                        db.get(response.id, function(err, doc) {
                            $scope.list.push(doc);
                        });
                    }
                });
            }
            console.log(toServer);
            if(toServer.length>0)
                var lastKeyId=toServer[toServer.length-1].keyId;
            for (var i = 0; i < toServer.length; i++) {
                var doc = toServer[i];
                console.log(doc.keyId + " is to sent");
                http.addGuest(doc).then(function(res) {
                    console.log(res);
                    if(res.keyId==lastKeyId){
                        for (var i = 0; i < update.length; i++) {
                            db.put(update[i], function(err, res) {
                                if (err) {
                                    tools.toast("Database error");
                                } else {
                                    var index = localStorage.getItem('updateIndex') + 1;
                                    localStorage.setItem('updateIndex', index);
                                    if (index == update.length) {
                                        db.allDocs({
                                            include_docs: true
                                        }, function(error, response) {
                                            for (var k = 0; k < response.total_rows; k++) {
                                                var doc = response.rows[k].doc;
                                                if (doc.adminName === x.adminName) {
                                                    for (var m = 0; m < $scope.list.length; m++) {
                                                        if (doc.keyId == $scope.list[m].keyId) {
                                                            $scope.list[m]._id = doc._id;
                                                            $scope.list[m]._rev = doc._rev;
                                                            console.log($scope.list[m].keyId + " refreshed");
                                                            break;
                                                        }
                                                    }
                                                }
                                            }
                                        });
                                    }
                                }
                            });
                        }
                    }
                }, function(err) {
                    $ionicPopup.alert({
                        title:'Sync failed',
                        subTitle:err.msg
                    });        
                });
            }
            localStorage.setItem("updateIndex", 0);           
            $scope.loading.hide();
        }, function(err) {
            $ionicPopup.alert({
                title:'Sync failed',
                subTitle:err.msg
            });
            $scope.loading.hide();
        });
    }
    $scope.enableDisable = function(item, index) {
        $scope.loading.show();
        http.enableDisable({
            keyId: item.keyId,
            enable: item.enable
        }).then(function(res) {
            console.log(res);
            $scope.loading.hide();
            db.put($scope.list[index], function(err, res) {
                console.log(err, res);
                $scope.list[index]._id = res.id;
                $scope.list[index]._rev = res.rev;
            });
        }, function(err) {
            $scope.loading.hide();
            $scope.list[index].enable = !item.enable;
            db.put($scope.list[index], function(err, res) {
                console.log(err, res);
                $scope.list[index]._id = res.id;
                $scope.list[index]._rev = res.rev;
            });
        });
    }
    $scope.edit = function(key, obj) {
        console.log(obj);
        db.allDocs({include_docs: true}, function(err, res){
            for (var i = 0; i < res.total_rows; i++) {
                obj = res.rows[i].doc;
                if(obj.keyId == key){
                    console.log(obj);
                    if (x.lockType !== "BKW") {
                        localStorage.setItem('editItem', JSON.stringify(obj));
                        $state.go('BLEGuestAdd', {
                            edit: true
                        });
                        return;
                    }
                    localStorage.setItem('editItem', JSON.stringify(obj));
                    $state.go('add_Guest.invite', {
                        edit: true
                    });
                    break;
                }
            }
        });
    }
    $scope.alertTimeChanged = function(obj, index) {
        var options = {
            date: new Date(),
            mode: 'datetime'
        };

        function onError(error) { // Android only
            console.log('Error: ' + error);
        }
        datePicker.show(options, function(date) {
            list[index].alertTime = date;
            db.put(list[index], function(error, response) {
                if (error) console.log(error);
                if (response) {
                    console.log("Alert time updated" + response);
                    $scope.list[index]._id = response.id;
                    $scope.list[index]._rev = response.rev;
                }
            });
        }, onError);
    }
    $scope.share = function(keyId, guestName, keypad) {
        var keypadMsg = ""
        if (keypad == 0 || keypad == null) {
            keypadMsg = "";
        } else {
            keypadMsg = " and keypad code " + keypad + "";
        }
        if ($scope.lockType == 'BKW') {
            keyId = "bkw" + keyId;
        } else {
            keyId = x.currentLock + keyId;
        }
        var loginObj = JSON.parse(localStorage.getItem('login'));
        var msg = "Hello " + guestName + ", " + loginObj.name + " has added you in the guest list with key ID " + keyId + keypadMsg + ". Please Download our app Smart Lock to talk to the lock through your smartphone here.";
        console.log(msg);
        var link = "https://play.google.com/store/apps/details?id=com.darshanaindustries.app&hl=en";
        window.plugins.socialsharing.share(msg, null, null, link);
    }
    document.addEventListener("deviceready", onDeviceReady, false);

    function onDeviceReady() {}
    var interval;

    function startInterval() {
        interval = setInterval(function() {
            try {
                var i;
                for (i = 0; i < $scope.list.length; i++) {
                    var time = $scope.list[i].checkOut;
                    var alertTime = $scope.list[i].alertTime;
                    var date = new Date();
                    var endIn = guestTimeout.getTimeRemaining(time);
                    if (date > alertTime && alertTime != time) {
                        $scope.list[i].alertTime = $scope.list[i].checkOut;
                        var index = i;
                        db.put($scope.list[i], function(err, res) {
                            console.log(err);
                            if (res) {
                                console.log(res);
                                $scope.list[index]._id = res.id;
                                $scope.list[index]._rev = res.rev;
                                console.log(i);
                            }
                        });
                        var obj = $scope.list[i];
                        popup = $ionicPopup.confirm({
                            title: "Extend?",
                            template: "The stay of " + $scope.list[i].name + " (" + $scope.list[i].keyId + ") will end in " + endIn.days + " days " + endIn.hours + " hours " + endIn.minutes + " minutes " + endIn.seconds + " seconds. Do you want to extend?"
                        }).then(function(res) {
                            if (res) {
                                /*if(window.Connection) {
                                    if(navigator.connection.type == Connection.NONE) {
                                        console.log("No internet connection");
                                    }
                                    else{*/
                                if (obj != null) {
                                    localStorage.setItem('editItem', JSON.stringify(obj));
                                    if ($scope.lockType !== 'BKW') {
                                        $state.go('BLEGuestAdd', {
                                            edit: true
                                        }, {
                                            reload: true
                                        });
                                    } else {
                                        $state.go('add_Guest.invite', {
                                            edit: true
                                        });
                                    }
                                }
                                /*}
                                }*/
                            } else {
                                console.log("Extention cancelled");
                            }
                        });
                    }
                    $scope.list[i].timeRemaining = endIn;
                    $scope.list[i].alertTimeRemaining = guestTimeout.getTimeRemaining(alertTime);
                    var date1 = new Date($scope.list[i].checkOut);
                    if (date > date1) {
                        $scope.list[i].timeRemaining = "";
                    }
                }
            } catch (e) {
                console.log(e);
            }
            $scope.$apply();
        }, 1000);
    }
    startInterval();
    $scope.allMacs = allMacs;

    /*--------------------DELETE------------------*/
    $scope.delete = function(id, rev, key) {
        console.log(id, rev);
        db.allDocs({include_docs: true}, function(err, res){
            for (var i = 0; i < res.total_rows; i++) {
                var doc = res.rows[i].doc;
                if(doc.keyId == key){
                    id = doc._id;
                    rev = doc._rev;
                    break;
                }
            }
        })
        console.log(id, rev);
        var loginObj = JSON.parse(localStorage.getItem('login'));
        $ionicPopup.show({
            template: "Are you sure?",
            title: "Delete",
            scope: $scope,
            buttons: [{
                text: "Cancel"
            }, {
                text: "OK",
                onTap: function(e) {
                    if (loginObj.lockType !== 'BKW') {
                        $scope.loading.show();
                        ngBLE.connect(x.bleId).then(null, function(err){
                            deleteFail(key);
                            $scope.loading.hide();
                        }, function(res){
                            if(res.msg == 'connected'){
                                $scope.connected = true;
                                ngBLE.discover(x.bleId).then(function(res){
                                    ngBLE.subscribe(x.bleId).then(null, null, function(success){
                                        if(success==='subscribed'){
                                            ngBLE.write(x.bleId, "wdelete " + key + " ");
                                            return;
                                        }
                                        success = success.trim();
                                        if (success === 'deleted' || success === 'userid not present') {
                                            $scope.loading.hide();
                                            ngBLE.disconnect();
                                            db.remove(id, rev, function(error, response) {
                                                tools.hideLoad();
                                                if (error) {
                                                    console.log(error);
                                                }
                                                if (response) {
                                                    var i;
                                                    for (i = 0; i < $scope.list.length; i++) {
                                                        if ($scope.list[i].keyId == key) {
                                                            $scope.list.splice(i, 1);
                                                            $scope.$apply();
                                                            if(success==='deleted')
                                                                tools.toast("Guest deleted.");
                                                            else
                                                                tools.toast("User not present, guest deleted.");
                                                        }
                                                    }
                                                }
                                            });
                                        }
                                    });
                                });
                            }else{
                                $scope.loading.hide();
                            }
                        });
                        return;
                    }
                    http.deleteGuest({
                        keyId: key
                    }).then(function(success) {
                        tools.toast(success.msg);
                        db.remove(id, rev, function(error, response) {
                            tools.hideLoad();
                            if (response) {
                                var i;
                                for (i = 0; i < $scope.list.length; i++) {
                                    if ($scope.list[i].keyId == key) {
                                        $scope.list.splice(i, 1);
                                        $scope.$apply();
                                    }
                                }
                            }
                        });
                    }, function(error) {
                        tools.toast(error.msg);
                        db.remove(id, rev, function(error, response) {
                            tools.hideLoad();
                            if (response) {
                                var i;
                                for (i = 0; i < $scope.list.length; i++) {
                                    if ($scope.list[i].keyId == key) {
                                        $scope.list.splice(i, 1);
                                        $scope.$apply();
                                    }
                                }
                            }
                        });
                    });
                }
            }]
        });
    }

    function deleteFail(key) {
        tools.hideLoad();
        var index;
        for (i = 0; i < $scope.list.length; i++) {
            if ($scope.list[i].keyId == key) {
                index = i;
                break;
            }
        }
        $scope.list[index].global = false;
        $scope.list[index].opacity = "0.4";
        db.post($scope.list[index], function(err, res) {
            console.log(err, res);
            var toDelete = JSON.parse(localStorage.getItem("toDelete"));
            if (toDelete === null || toDelete === undefined) {
                toDelete = {
                    items: []
                };
            }
            var obj = {
                keyId: key,
                lock: x.currentLock
            }
            toDelete.items.push(obj);
            localStorage.setItem("toDelete", JSON.stringify(toDelete));
        });
    }
}).controller('menuCtrl', function($scope, $state, $stateParams, $ionicPlatform, $ionicSideMenuDelegate, $ionicActionSheet, $ionicPopover, $ionicLoading, tools, http) {
    $scope.admin = false;
    $scope.load = false;
    $scope.data = {
        adminOpacity: "0.4",
        guestOpacity: "0.4",
        imageUri: "",
        lockName: "Locks",
        locksOpacity: "0.4",
        keypadOpacity: "0.4",
    }
    $scope.newNotificationsNumber = 0;
    var loginObj;
    $scope.locks = [];
    $scope.choice = false;
    var popover;
    $scope.state = $state;
    setInterval(function() {
        var loginObj = JSON.parse(localStorage.getItem('login'));
        try {
            $scope.loginObj = loginObj;
            if (loginObj != null) {
                if (loginObj.isLogged == true) {
                    $scope.name = loginObj.name;
                    if (loginObj.type == 'admin') {
                        $scope.role = "Admin";
                        $scope.admin = true;
                        $scope.data.imageUri = loginObj.imageUri;
                        $scope.data.adminOpacity = "1";
                        $scope.data.guestOpacity = "0.4";
                        if (loginObj.locks.length > 0) {
                            $scope.data.locksOpacity = "1";
                            $scope.data.lockName = loginObj.currentLockName;
                        } else {
                            $scope.data.locksOpacity = "0.4";
                            $scope.data.lockName = "Home";
                        }
                        if (loginObj.lockType === "B") {
                            $scope.data.keypadOpacity = "0.4";
                        } else {
                            $scope.data.keypadOpacity = "1";
                        }
                    } else {
                        $scope.role = "Guest";
                        $scope.data.keypadOpacity = "0.4";
                        $scope.data.lockName = "Home";
                        $scope.data.locksOpacity = "1";
                        $scope.admin = false;
                        $scope.data.imageUri = loginObj.imageUri;
                        $scope.data.adminOpacity = "0.4";
                        $scope.data.guestOpacity = "1";
                    }
                }
            }
            $scope.$apply();
        } catch (e) {
            console.log(e);
        }
    }, 1000);
    
    $scope.load = true;
    //===================================LOGOUT==========================================
    $scope.logout = function() {
        loginObj = JSON.parse(localStorage.getItem('login'));
        console.log(loginObj);
        if(loginObj.isLogged == true && loginObj.type == 'admin'){
            var deviceName = "Ionic";
            var uuid = "random something";
            try{
                deviceName = deviceInfo.manufacturer + " "+ deviceInfo.model;
                uuid = deviceInfo.uuid;
            }catch(e){
                console.log(e);
            }
            http.logout({
                adminEmail: loginObj.adminName,
                uuid: uuid
            }, function(res){
                console.log(res);
                if(typeof FCMPlugin==='object'){
                    for(var i = 0; i < loginObj.locks.length; i++){
                        FCMPlugin.unsubscribeFromTopic(loginObj.locks[i].client_id, function(msg){
                            console.log(msg);
                        }, function(err){
                            console.log(err);
                        });
                    }
                }
                loginObj.isLogged = false;
                loginObj.imageUri = "img/avatar.png";
                localStorage.setItem('login', JSON.stringify(loginObj)); 
                $state.go('login', {
                    reload: true
                });
            }, function(err){
                console.log(err);
                tools.toast(err.msg);
            });
        }else{
            loginObj.isLogged = false;
            loginObj.imageUri = "img/avatar.png";
            localStorage.setItem('login', JSON.stringify(loginObj)); 
            $state.go('login', {
                reload: true
            });
        }
    }
    //===================================================================================

    //=============================SWITCH LOCK============================================
    $scope.changeLock = function($event) {
        loginObj = JSON.parse(localStorage.getItem('login'));
        $scope.locks = loginObj.locks;
        for (var i = 0; i < $scope.locks.length; i++) {
            var lockName;
            if($scope.locks[i].alias){
                lockName=$scope.locks[i].alias+" ("+$scope.locks[i].client_id+")";
            }else{
                lockName=$scope.locks[i].client_id;
            };
            $scope.locks[i].text = lockName;
        }
        var sheet = $ionicActionSheet.show({
            buttons: $scope.locks,
            titleText: 'Select lock',
            cancelText: 'Cancel',
            cancel: function() {},
            buttonClicked: function(index) {
                var lock = $scope.locks[index];
                console.log(lock);
                $ionicSideMenuDelegate.toggleLeft(false);
                var lockName;
                (lock.alias)?lockName=lock.alias:lockName=lock.client_id;
                loginObj = JSON.parse(localStorage.getItem('login'));
                loginObj.currentLock = lock.client_id;
                loginObj.currentLockName = lockName;
                loginObj.bleId = lock.ble_id;
                loginObj.macId = lock.mac_id;
                loginObj.lockType = lock.lockType;
                loginObj.passcode = lock.passcode;
                localStorage.setItem('login', JSON.stringify(loginObj));
                if (loginObj.lockType !== "BKW") {
                    $state.go("ble", {}, {
                        reload: true
                    });
                } else if (loginObj.lockType == "BKW") {
                    $state.go("home", {}, {
                        reload: true
                    });
                }
                return true;
            }
        });
    }
    //========================================================================================

    //===================================SET PROFILE PICTURE====================================
    $scope.setPicture = function() {
        console.log("Picture");
        $ionicActionSheet.show({
            buttons: [{
                text: 'Take photo'
            }, {
                text: 'Select from gallery'
            }],
            titleText: '<center>Select profile picture.</center>',
            cancelText: '<center>Cancel<center>',
            buttonClicked: function(index) {
                var loginObj = JSON.parse(localStorage.getItem('login'));
                console.log(index);
                if (index == 0) {
                    navigator.camera.getPicture(cameraSuccessCallback, cameraFailureCallback, {
                        sourceType: Camera.PictureSourceType.CAMERA,
                        destinationType: Camera.DestinationType.FILE_URI,
                        targetWidth: 250,
                        targetHeight: 250,
                        allowEdit: true,
                        correctOrientation: true
                    });

                    function cameraSuccessCallback(imageUri) {
                        loginObj.imageUri = imageUri;
                        console.log(imageUri);
                        localStorage.setItem('login', JSON.stringify(loginObj));
                    }

                    function cameraFailureCallback(error) {
                        console.log(error);
                    }
                }
                if (index == 1) {
                    navigator.camera.getPicture(function(imageUri) {
                        loginObj.imageUri = imageUri;
                        console.log(imageUri);
                        localStorage.setItem('login', JSON.stringify(loginObj));
                    }, function(message) {
                        console.log(message);
                    }, {
                        sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
                        destinationType: Camera.DestinationType.FILE_URI,
                        targetWidth: 250,
                        targetHeight: 250,
                        allowEdit: true,
                        correctOrientation: true
                    })
                }
                return true;
            }
        });
    }
    //=========================================================================================

    //=================================NAVIGATE================================================
    $scope.redirect = function(state) {
        $ionicSideMenuDelegate.toggleLeft(false);
        console.log("redirect");
        if (state == "home") {
            var loginObj = JSON.parse(localStorage.getItem('login'));
            if (loginObj.isLogged && loginObj.type == "guest") {
                state = 'ble';
            }
            if (loginObj.isLogged && loginObj.type == "admin" && loginObj.lockType !== "BKW") {
                state = 'ble';
            }
        }
        if (state == 'notifications') {
            $scope.newNotificationsNumber = 0;
        }
        $state.go(state);
    }
    //===========================================================================================

    //===============================GET NOTIFICATIONS FROM SERVER==============================
    function retrieveNotifications() {
        var loginObj = JSON.parse(localStorage.getItem('login'));
        if (loginObj.isLogged === true && loginObj.type === 'admin') {
            http.getNotification({
                adminName: loginObj.adminName
            }).then(function(res) {
                console.log(res);
                var newNotifications = res;
                $scope.newNotificationsNumber += res.length;
                for (var i = 0; i < res.length; i++) {
                    var date = new Date(res[i].timestamp);
                    var data = {
                        msg: res[i].guestEmail + " opened the door via " + res[i].via +'.',
                        date: date.getTime(),
                        day: date.getDay(),
                        lock: res[i].client_id,
                        id: res[i].id
                    };
                    var notifications = JSON.parse(localStorage.getItem('notifications'));
                    if (notifications != null) {
                        var array = notifications.array;
                        array.push(data)
                        json = {
                            array: array
                        }
                        localStorage.setItem('notifications', JSON.stringify(json));
                    }
                    if (notifications == null) {
                        var array = [];
                        array.push(data)
                        json = {
                            array: array
                        }
                        localStorage.setItem('notifications', JSON.stringify(json));
                    }
                }
            }, function(err) {
                console.log(err);
            });
        }
    }
    //==========================================================================================

    //============================FIREBASE INITIALIZATION=======================================
    var loginObj = JSON.parse(localStorage.getItem('login'));
    $ionicPlatform.ready(function() {
        retrieveNotifications();
        if(typeof FCMPlugin === 'object'){
            FCMPlugin.getToken(function(token) {
                console.log(token);
                // FCMPlugin.subscribeToTopic('test');
                var loginObj = JSON.parse(localStorage.getItem('login'));
                if (loginObj == null || loginObj.isLogged === false || loginObj.locks == null || loginObj.locks.length == 0) {
                    // console.log("No locks or not logged in or not a admin.");
                } else {
                    for (var i = 0; i < loginObj.locks.length; i++) {
                        if (loginObj.locks[i].lockType === "BKW") {
                            FCMPlugin.subscribeToTopic(loginObj.locks[i].client_id);
                        }
                    }
                }
            }, function(err) {
                console.log('error retrieving token: ' + err);
            })
            FCMPlugin.onNotification(function(data) {
                // console.log(data);
                retrieveNotifications();
                navigator.vibrate(350);
            }, function(msg) {
                // console.log('onNotification callback successfully registered: ' + msg);
            }, function(err) {
                console.log('Error registering onNotification callback: ' + err);
            });
        }
    });
    //========================================================================================

}).controller('guestSettingsCtrl', function($scope, guestTimeout, tools, $ionicHistory, $ionicPopup, $ionicActionSheet) {
    tools.hideLoad();
    var loginObj = JSON.parse(localStorage.getItem('login'));
    $ionicHistory.clearHistory();
    $scope.timeRemaining = "";
    $scope.data = {
        alertTime: loginObj.alertTime
    }
    var checkOut = new Date(loginObj.checkOut);
    var date = new Date();
    var total = Date.parse(checkOut) - Date.parse(new Date())
    $scope.flip = total / (1000);
    setInterval(function() {
        if (loginObj != null) {
            if (loginObj.isLogged == true && loginObj.type == 'guest') {
                $scope.timeRemaining = guestTimeout.getTimeRemaining(checkOut);
                $scope.$apply();
            }
        }
    }, 1000);
    $scope.changeAlertTime = function() {
        var options = {
            date: new Date($scope.data.alertTime),
            mode: 'datetime',
            androidTheme: plugins.datePicker.ANDROID_THEMES.THEME_DEVICE_DEFAULT_LIGHT
        }

        function onError(error) { // Android only
            console.log('Error: ' + error);
        }
        datePicker.show(options, function(date) {
            $scope.data.alertTime = date;
        }, onError);
    }
    $scope.$watch('data.alertTime', function() {
        console.log("Alert time changed:" + $scope.data.alertTime);
        if ($scope.data.alertTime != null) {
            loginObj.alertTime = new Date($scope.data.alertTime);
            var date1 = new Date($scope.data.alertTime);
            var date2 = new Date(loginObj.checkOut);
            console.log(date1 + " " + date2);
            if (date1 > date2) {
                console.log("Alert time cannot be past check out time.");
                $ionicPopup.alert({
                    title: "Date Error",
                    content: "Alert time cannot be past check out time. Default will be used."
                });
                loginObj.alertTime = new Date(new Date(loginObj.checkOut) - 5 * 60000);
                $scope.data.alertTime = loginObj.alertTime;
            }
            localStorage.setItem('login', JSON.stringify(loginObj));
        }
    });
    $.each($('.clock'), function() {
        $(this).click(function(e) {
            e.preventDefault();
        });
        var clock = $('.clock').FlipClock($scope.flip, {
            clockFace: 'DailyCounter',
            countdown: true
        });
    });
}).controller('lockSetupCtrl', function($scope, $ionicPlatform, $ionicLoading, tools, $ionicPopup, ngBLE) {
    $scope.loading=$ionicLoading;
    $scope.networks=[];
    
    $scope.scan=function(){
        $scope.loading.show();
        cordova.plugins.diagnostic.isLocationAvailable(function(available){
            if(!available){
                cordova.plugins.diagnostic.requestLocationAuthorization(function(status){
                    switch(status){
                        case cordova.plugins.diagnostic.permissionStatus.NOT_REQUESTED:
                            console.log("Permission not requested");
                            break;
                        case cordova.plugins.diagnostic.permissionStatus.GRANTED:
                            console.log("Permission granted");
                            scan();
                            break;
                        case cordova.plugins.diagnostic.permissionStatus.DENIED:
                            console.log("Permission denied");
                            break;
                        case cordova.plugins.diagnostic.permissionStatus.DENIED_ALWAYS:
                            console.log("Permission permanently denied");
                            break;
                    }
                }, function(error){
                    console.error(error);
                });
            }else{
                scan();
            }
        }, function(error){
            console.error("The following error occurred: "+error);
        });
        
    }

    function scan(){
        WifiWizard.setWifiEnabled(true, function(res){
            WifiWizard.startScan(function(res){
                WifiWizard.getScanResults({}, function(res){
                    console.log(res);
                    $scope.networks=res;
                    $scope.loading.hide();
                }, function(err){
                    tools.toast("Could not scan wifi networks.");
                    $scope.loading.hide();
                });
            }, function(err){
                tools.toast("Could not scan wifi networks.");
                $scope.loading.hide();
            });
        }, function(res){
            tools.toast("Could not enable Wifi.");
            $scope.loading.hide();
        });
    }

    $ionicPlatform.ready(function(){
        $scope.scan();
    });

    $scope.sendToLock=function(i){
        var password;
        $ionicPopup.prompt({
            title: "Wifi Setup",
            subTitle: 'Enter password for '+$scope.networks[i].SSID,
            template: 'Turn ON Bluetooth and stay in range of the lock.',
            inputType: 'password',
            inputPlaceholder: '12345678'
        }).then(function(resPassword) {
            console.log(resPassword);
            if(!resPassword){
                return;
            }
            password=resPassword
            $scope.loading.show();
            var loginObj=JSON.parse(localStorage.login);
            ngBLE.connect(loginObj.bleId).then(null, function(err){
                $scope.loading.hide()
                tools.toast(err.msg);
            }, function(res){
                if(res.msg==='connected'){
                    ngBLE.discover(loginObj.bleId).then(function(res){
                        ngBLE.subscribe(loginObj.bleId).then(null, null, function(res){
                            if(res==='subscribed'){
                                ngBLE.write(loginObj.bleId, 'wapiname '+$scope.networks[i].SSID+' ');
                            }
                            res=res.trim();
                            if(res==='namestored'){
                                ngBLE.write(loginObj.bleId, 'wapipass '+password+' ');
                            }
                            if(res==='passstored'){
                                ngBLE.disconnect()
                                $scope.loading.hide()
                                $ionicPopup.alert({
                                    title:'Wifi Setup',
                                    subTitle:"Success"
                                });
                            }
                        });
                    });
                }else{
                    $scope.loading.hide();
                }
            });
        });
    }
})
.controller('notificationsCtrl', function($scope, $stateParams, $ionicPlatform, $ionicHistory, 
    $interval, tools, ngBLE, $ionicPopup) {
    $ionicHistory.clearHistory();
    tools.hideLoad();
    $scope.logs = [];
    $scope.days = ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"];

    function check() {
        var loginObj = JSON.parse(localStorage.getItem('login'));
        var obj = JSON.parse(localStorage.getItem('notifications'));
        var logs = []
        if (obj != null) {
            var deleteArray = [];
            var date = new Date();
            var nowDate = new Date();
            nowDate.setMinutes(nowDate.getMinutes()+60);
            date.setDate(date.getDate() - 7);
            for (var i = 0; i < obj.array.length; i++) {
                var compDate = new Date(obj.array[i].date);
                if (compDate.getTime() > date.getTime() && compDate.getTime() < nowDate.getTime()) {
                    if (obj.array[i].lock == loginObj.currentLock) {
                        logs.push(obj.array[i]);
                    }
                } else {
                    deleteArray.push(i);
                }
            }
            for (var i = 0; i < deleteArray.length; i++) {
                obj.array.splice(deleteArray[i], 1);
                var jsonData = {
                    array: obj.array
                }
                console.log("deleted");
            }
            if (jsonData != null) {
                localStorage.setItem('notifications', JSON.stringify(jsonData));
            }
            for (var i = 0; i < logs.length; i++) {
                var found = false;
                for (var j = 0; j < $scope.logs.length; j++) {
                    if ($scope.logs[j].date == logs[i].date) {
                        var found = true;
                        break;
                    }
                }
                if (found == false) {
                    $scope.logs.push(logs[i]);
                }
            }
            if (!$scope.$$phase) {
                $scope.$apply();
            }
        }
    }

    $scope.check = function() {
        check();
    }
    $ionicPlatform.ready(function() {
        check();
    })
    var interval = $interval(function() {
        check();
    }, 2000)
    $scope.$on('$destroy', function() {
        clearInterval(interval);
    });
    $scope.deleteAll = function() {
        $scope.logs = [];
        var array = [];
        json = {
            array: array
        }
        localStorage.setItem('notifications', JSON.stringify(json));
    }
    $scope.delete = function(deleteObj, index) {
        var notificationJSON = JSON.parse(localStorage.getItem('notifications'));
        console.log(notificationJSON.array);
        var array = notificationJSON.array;
        for (var i = 0; i < array.length; i++) {
            var compDate = new Date(deleteObj.date);
            var compDate1 = new Date(array[i].date);
            // console.log(compDate.getTime()+" "+compDate1.getTime());
            if (compDate.getTime() == compDate1.getTime()) {
                console.log("deleted");
                array.splice(i, 1);
                var json = {
                    array: array
                }
                localStorage.setItem('notifications', JSON.stringify(json));
                break;
            }
        }
        $scope.logs.splice($scope.logs.indexOf(deleteObj), 1);
    }
}).controller('batteryCtrl', function($scope, $stateParams, $interval, $ionicPlatform, 
    ngBLE, tools, $ionicHistory, $ionicLoading) {
    $ionicHistory.clearHistory();
    tools.hideLoad();
    $scope.data = {
        percent: 75
    };
    colorify();
    $scope.loading=$ionicLoading;
    $scope.refresh = function() {
        get();
    }
    $ionicPlatform.ready(function() {
        get();
    });
    var myTimeout;

    function get() {
        var loginObj = JSON.parse(localStorage.getItem('login'));
        $scope.loginObj = loginObj;
        var locks=loginObj.locks;
        var found=false;
        for(var i=0;i<locks.length;i++){
            if(locks[i].client_id===loginObj.currentLock){
                $scope.data.percent=Number(locks[i].battery);
                break;
            }
        }

        if (loginObj.lockType !== 'BKW') {
            if (myTimeout !== undefined && myTimeout !== null) {
                clearTimeout(myTimeout);
            }
            $scope.loading.show();
            ngBLE.connect(loginObj.bleId).then(null, function(err){
                $scope.loading.hide();
            }, function(res){
                if(res.msg == 'connected'){
                    $scope.connected = true;
                    ngBLE.discover(loginObj.bleId).then(function(res){
                        ngBLE.subscribe(loginObj.bleId).then(null, null, function(success){
                            if(success==='subscribed'){
                                // ngBLE.write(loginObj.bleId, "hitron123/");
                                ngBLE.write(loginObj.bleId, 'wbstatus battery ');
                                return;
                            }
                            $scope.loading.hide();
                            var percentage=Number(success.trim());
                            clearTimeout(myTimeout);
                            tools.toast('Battery updated.')
                            if (found == false) {
                                battery.locks.push({
                                    lock: loginObj.currentLock,
                                    battery: percentage
                                });
                            } else {
                                battery.locks[index].battery = percentage;
                            }
                            $scope.data.percent = percentage;
                            colorify();
                            ngBLE.disconnect();
                        });
                    });
                }else{
                    $scope.loading.hide();
                }
            });
        }else{
            var params = {
                client_id: loginObj.currentLock
            }
            $scope.loading.show();
            tools.batteryApi(params, function(res){
                console.log(res);
                $scope.loading.hide();
                if(res.battery == null || res.battery == undefined){
                    tools.hideLoad();
                    return;
                }
                tools.toast('Battery status updated!')
                $scope.data.percent = res.battery;
                colorify();
                localStorage.setItem("battery", JSON.stringify(battery));
                tools.hideLoad();
            }, function(err){
                console.log(err);
                $scope.loading.hide();
            });
        }
    }
    $scope.$on("$destroy", function() {
        if (loginObj.lockType !== 'BKW') {
            ngBLE.disconnect();
        }
    });

    function colorify() {
        if ($scope.data.percent !== 0) {
            if ($scope.data.percent <= 20) {
                $scope.color = "red";
            } else {
                $scope.color = "#31b0d5";
            }
        }
    }
}).controller('keypadCtrl', function($scope, $stateParams, checkKeypad, $ionicPopup, 
    $ionicPlatform, tools, ngBLE, $ionicLoading) {
    tools.hideLoad();
    $scope.data = {
        oldKey: "",
        newKey: ""
    }
    var myTimeout;
    $scope.loading=$ionicLoading;
    var loginObj = JSON.parse(localStorage.getItem('login'));
    $scope.loginObj = loginObj;
    console.log(loginObj);
    $scope.getCurrent = function() {
        var locks=loginObj.locks;
        console.log(loginObj);
        console.log(JSON.parse(localStorage.getItem('login')));
        for (var i = 0; i < locks.length; i++) {
            if (locks[i].client_id == loginObj.currentLock) {
                console.log('Your current keypad ID is: ' + locks[i].adminKeypad);
                navigator.notification.alert('Your current keypad ID is: ' + locks[i].adminKeypad);
                break;
            }
        }
    }
    $scope.$on("$destroy", function() {
        ngBLE.disconnect();
    });
    $scope.change = function() {
        $scope.loading.show();
        if (loginObj.lockType === 'BKW') {
            checkKeypad.verify({
                client_id: loginObj.currentLock,
                keypad: Number($scope.data.newKey)
            }, function(res) {
                $scope.loading.hide();
                console.log(res);
                if (res.type == false) 
                    return;
                $ionicPopup.alert({
                    content: '<center>Updated</center>'
                });
                var locks=loginObj.locks;
                for (var i = 0; i < locks.length; i++) {
                    if (locks[i].client_id == loginObj.currentLock) {
                        loginObj.locks[i].adminKeypad=Number($scope.data.newKey);
                        localStorage.setItem('login',JSON.stringify(loginObj));
                        break;
                    }
                }
            }, function(err) {
                console.log(err);
                $scope.loading.hide();
                tools.toast('No internet connection or error on server.');
            });
        } else {
            ngBLE.connect(loginObj.bleId).then(null, function(err){
                $scope.loading.hide();
            }, function(res){
                if(res.msg == 'connected'){
                    $scope.connected = true;
                    ngBLE.discover(loginObj.bleId).then(function(res){
                        ngBLE.subscribe(loginObj.bleId).then(null, null, function(res){
                            if(res==='subscribed'){
                                // ngBLE.write(loginObj.bleId, "hitron123/");
                                ngBLE.write(loginObj.bleId, 'wadkey ' + $scope.data.newKey + ' ');
                                return;
                            }
                            $scope.loading.hide();
                            res = res.trim();
                            if (res === 'master pass set') {
                                $scope.loading.hide();
                                ngBLE.disconnect();
                                tools.toast('Keypad passcode changed.');
                                var locks=loginObj.locks;
                                for (var i = 0; i < locks.length; i++) {
                                    console.log(locks[i].client_id, loginObj.currentLock);
                                    if (locks[i].client_id == loginObj.currentLock) {
                                        loginObj.locks[i].adminKeypad=Number($scope.data.newKey);
                                        localStorage.setItem('login',JSON.stringify(loginObj));
                                        break;
                                    }
                                }
                            }
                        });
                    });
                }else{
                    $scope.loading.hide();
                }
            });
        }
    }
}).controller('addLockCtrl', function($scope, $cordovaBluetoothLE, $ionicLoading,
    $ionicPopup, CheckMAC, $state, ngBLE, Devices, tools, http, WizardHandler, $http) {
    $scope.$on("$destroy", function() {
        ngBLE.disconnect();
    });
    tools.hideLoad();
    Devices.clean();
    $scope.locks = Devices.all();
    $scope.data = {
        locationSharing: false
    };
    $scope.isDetectingLocation = false;
    $scope.location = "";
    $scope.authenticated = false;
    $scope.data = {
        choice: false,
        authenticationCode: "",
        productID: ""
    };
    $scope.loading=$ionicLoading;
    $scope.intervals = ['Always on', '30 min', '1 hr', '3 hr', '6 hr', '12 hr'];
    var addressConnected;
    var nameConnected;
    $scope.getLocation = function() {
        $scope.isDetectingLocation = true;
        $scope.location = "";
        if ($scope.data.locationSharing == false) {
            $scope.isDetectingLocation = false;
            return 0;
        }
        console.log($scope.data.locationSharing, $scope.isDetectingLocation);
        var area = "";
        var district = "";
        var options = {
            enableHighAccuracy: true,
            maximumAge: 3000
        }
        var watchID = navigator.geolocation.getCurrentPosition(onSuccess, onError, options);

        function onSuccess(position) {
            console.log(position);
            var lat = position.coords.latitude;
            var lng = position.coords.longitude;
            $http.get("https://maps.googleapis.com/maps/api/geocode/json?latlng=" + lat + "," + lng + "&sensor=true").then(function(response) {
                var data = response.data.results[0].address_components;
                var sublocality = false;
                for (var i = 0; i < data.length; i++) {
                    for (var j = 0; j < data[i].types.length; j++) {
                        if (data[i].types[j] === 'sublocality') {
                            sublocality = true;
                            console.log("Area: " + data[i].long_name);
                            area = data[i].long_name;
                            break;
                        }
                    }
                    if (sublocality === false) {
                        for (var j = 0; j < data[i].types.length; j++) {
                            if (data[i].types[j] === 'locality') {
                                sublocality = true;
                                console.log("Area: " + data[i].long_name);
                                area = data[i].long_name;
                                break;
                            }
                        }
                    }
                    for (var k = 0; k < data[i].types.length; k++) {
                        if (data[i].types[k] === 'administrative_area_level_2') {
                            console.log("District: " + data[i].long_name);
                            district = data[i].long_name;
                            break;
                        }
                    }
                }
                console.log("So finally: District: " + district + " and area: " + area);
                $scope.location = area + ", " + district;
                var arr = $scope.location.split(',');
                arr = [{
                    district: arr[1].trim(),
                    area: arr[0].trim()
                }];
                $scope.isDetectingLocation = false;
                console.log(arr);
            }, function(error) {
                console.log(error);
            });
        };

        function onError(error) {
            console.log(error);
            tools.toast("Could not detect location.");
            $scope.isDetectingLocation = false;
        }
    }
    $scope.getMac = function() {
        $scope.loading.show();
        var params={client_id:$scope.data.productID};
        http.getBleId(params).then(function(res) {
            $scope.loading.hide();
            if (res.type == 'Error') {
                $ionicPopup.alert({
                    title: "Error",
                    template: "<center>Product does not exist.</center>"
                });
            } else {
                var template = "<li>Turn Bluetooth ON</li><li>Stay in range of the lock</li>" + "<li>Click OK to continue the authentication process...</li>";
                $ionicPopup.show({
                    template: template,
                    title: "Login process",
                    scope: $scope,
                    buttons: [{
                        text: "Cancel"
                    }, {
                        text: "OK",
                        type: "button-positive",
                        onTap: function(e) {
                            console.log("authenticate");
                            addressConnected = res.doc.bleId;
                            $scope.authenticate(res.doc.bleId);
                        }
                    }]
                });
            }
        }, function(err) {
            console.log(err);
            $scope.loading.hide();
            tools.toast("Problem connecting to the internet...");
        })
    }
    $scope.authenticate = function(id) {
        
        var template = "<p>The code you are about to enter is provided to you with the lock.</p>" + "<input type='password' class='text-field' placeholder='abc456' ng-model='data.authenticationCode'>";
        $ionicPopup.show({
            title: "Enter the code",
            template: template,
            scope: $scope,
            buttons: [{
                text: "Cancel"
            }, {
                text: "OK",
                type: "button-positive",
                onTap: function(e) {
                    console.log($scope.data.authenticationCode);
                    if ($scope.data.authenticationCode != "") {
                        $scope.loading.show();
                        var code = $scope.data.authenticationCode;
                        authenticate(id, code);
                    } else {
                        tools.toast("Enter code.");
                    }
                }
            }]
        })
    }

    function authenticate(id, code) {
        var sendString = "";
        if ($scope.data.choice === 'BKW') {
            var interval = $scope.data.interval;
            if (interval == '1 hr') {
                minutes = 60;
            } else if (interval === '30 min') {
                minutes = 30;
            } else if (interval === '3 hr') {
                minutes = 180;
            } else if (interval === '6 hr') {
                minutes = 360;
            } else if (interval === '12 hr') {
                minutes = 720;
            } else if (interval === 'Always on') {
                minutes = 0;
            }
            if (minutes == 60 || minutes == 30) {
                var bleMinutes = "0" + minutes;
            } else if (minutes == 0) {
                var bleMinutes = "000";
            } else {
                var bleMinutes = minutes;
            }
        }
        sendString = "a" + code;
        var timeout;
        ngBLE.connect(id).then(null, function(err){
            console.log(err);
            $scope.loading.hide();
        }, function(res){
            if(res.msg==='connected'){
                ngBLE.discover(id, code).then(function(res){
                    ngBLE.subscribe(id).then(null, null, function(data){
                        if(data==='subscribed'){
                            ngBLE.write(id, sendString);
                            return;
                        }
                        data = data.trim();
                        if (data === 'authentic admin') {
                            $scope.error = "";
                            nameConnected = $scope.data.productID;
                            ngBLE.write(id, 'Rtc ' + tools.toBleDateFormat(new Date(), true) + " ");
                        }
                        if(data==="set rtc"){
                            $scope.authenticated = true;
                            if ($scope.data.choice == 'BKW') {
                                ngBLE.write(id, "s" + bleMinutes);
                                WizardHandler.wizard().next();
                            } else {
                                WizardHandler.wizard().next();
                            }
                            ngBLE.disconnect();
                            $scope.loading.hide();
                        }
                        if (data === "authentic fail") {
                            console.log("Authentication unsuccesful.");
                            $scope.authenticated=false;
                            ngBLE.disconnect(id);
                            $scope.loading.hide();
                            tools.toast("Authentication failed.");
                        }
                    });
                });
            }else{
                $scope.loading.hide();
            }
        });
    }
    $scope.verifyWithServer = function() {
        console.log("Wizard Finished");
        var loginObj = JSON.parse(localStorage.getItem('login'));
        $scope.loading.show();
        if ($scope.data.choice === 'BKW') {
            if ($scope.data.interval == "30 min") {
                $scope.data.interval = 0.5;
            } else if ($scope.data.interval == 'Always on') {
                $scope.data.interval = 0;
            } else {
                $scope.data.interval = $scope.data.interval.split(' ')[0];
            }
        } else {
            $scope.data.interval = 0;
        }
        var data = {
            passcode: $scope.data.authenticationCode,
            client_id: nameConnected,
            customer: loginObj.adminName,
            activated: true,
            interval: $scope.data.interval
        }
        if ($scope.data.locationSharing == true) {
            var arr = $scope.location.split(',');
            data.location = {
                district: arr[1].trim(),
                area: arr[0].trim()
            };
        } else {
            data.location = {
                district: "",
                area: ""
            };
        }
        if (loginObj.locks.length == 0) {
            data.adminToBeRegistered = true;
            data.adminData = loginObj.data;
        } else {
            data.adminToBeRegistered = false;
        }
        console.log(data);
        CheckMAC.verify(data, function(res) {
            loginObj.locks.push(res.doc);
            loginObj.bleId = addressConnected;
            loginObj.currentLock = nameConnected;
            loginObj.currentLockName = "new lock";
            loginObj.macId = res.doc.mac_id;
            loginObj.passcode = $scope.data.authenticationCode;
            loginObj.lockType = $scope.data.choice;
            localStorage.setItem('login', JSON.stringify(loginObj));
            $scope.loading.hide();
            $ionicPopup.alert({
                title: "Success",
                template: "<center>Your default keypad code is 1234, please change to avoid security breach.</center>"
            }).then(function(res){
                if ($scope.data.choice === 'BKW') {
                    $state.go('home');
                } else {
                    $state.go('ble');
                }
            });
        }, function(res) {
            $scope.loading.hide();
            tools.toast(res.msg);
        });
    }
}).controller('locksCtrl', function($scope, $state, $ionicPopup, tools, ngBLE, $ionicPlatform, $ionicModal, CheckMAC, $http, http, $ionicLoading) {
    $scope.locks = [];
    tools.hideLoad();
    $scope.data = {
        rename: "",
        locationToggle: false
    }
    $scope.loading=$ionicLoading;
    $scope.location = "";
    $scope.intervals = ['Always on', '30 min', '1 hr', '3 hr', '6 hr', '12 hr'];
    var timeout;
    $ionicPlatform.ready(function() {
        setTimeout(load, 200);
    });

    function load() {
        $scope.loading.show();
        var loginObj = JSON.parse(localStorage.getItem('login'));
        $scope.loginObj = loginObj;
        if (loginObj != null) {
            $scope.locks = loginObj.locks;
            for (var i = 0; i < $scope.locks.length; i++) {
                if($scope.locks[i].alias){
                    $scope.locks[i].name = $scope.locks[i].alias;
                }else{
                    $scope.locks[i].name = $scope.locks[i].client_id;
                }
            }
        }
        $scope.loading.hide();
    }
    $scope.addLock = function() {
        $state.go('addLock');
    }
    var oldValue="";
    $scope.$watch("locks[editLockIndex].interval", function(newValue, old){
        if(!old || !newValue)
            return;
        if(typeof old ==='number' || typeof newValue=='number')
            return;
        oldValue=old;
    });
    $scope.updateInterval=function(index){
        $scope.loading.show();
        var interval = $scope.locks[index].interval;
        var hours;
        if (interval == '1 hr') {
            minutes = 60;
            hours = 1;
        } else if (interval === '30 min') {
            minutes = 30;
            hours = 0.5;
        } else if (interval === '3 hr') {
            minutes = 180;
            hours = 3;
        } else if (interval === '6 hr') {
            minutes = 360;
            hours = 6;
        } else if (interval === '12 hr') {
            minutes = 720;
            hours = 12;
        } else if (interval === 'Always on') {
            minutes = 0;
            hours = 0;
        }
        if (minutes == 60 || minutes == 30) {
            var bleMinutes = "0" + minutes;
        } else if (minutes == 0) {
            var bleMinutes = "000";
        } else {
            var bleMinutes = minutes;
        }
        var data = {
            interval: hours,
            client_id: $scope.locks[index].client_id
        }
        var loginObj = JSON.parse(localStorage.getItem('login'));
        loginObj.locks[index].interval = hours;
        localStorage.setItem('login', JSON.stringify(loginObj));
        var id=$scope.locks[index].ble_id;
        ngBLE.connect(id).then(null,function(error){
            $scope.locks[index].interval=oldValue;
            $scope.loading.hide();
        }, function(res){
            if(res.msg==='connected'){
                ngBLE.discover(id).then(function(){
                    ngBLE.subscribe(id).then(null, null, function(success){
                        if(success==='subscribed'){
                            ngBLE.write(id, "s" + bleMinutes);
                            tools.toast("Interval updated.");
                            http.interval(data, function(success) {
                                console.log(success);
                                $scope.loading.hide();
                            }, function(error) {
                                console.log(error);
                                $scope.locks[index].interval=oldValue;
                                $scope.loading.hide();
                            });
                            ngBLE.disconnect();
                            return;
                        }
                    });
                });
            }else{
                $scope.loading.hide();
                $scope.locks[index].interval=oldValue;
            }
        });
    }
    $scope.rename = function(lock, index) {
        $scope.data.rename=$scope.locks[index].name;
        $ionicPopup.show({
            title: "Rename " + $scope.locks[index].name,
            templateUrl: "templates/templateUrls/renameLock.html",
            scope: $scope,
            buttons: [{
                text: 'Cancel',
            }, {
                text: 'Ok',
                type: 'button-positive',
                onTap: function(e) {
                    if ($scope.data.rename === "") {
                        e.preventDefault();
                        tools.toast('Name cannot be empty');
                        return;
                    }
                    $scope.loading.show();

                    var data = {
                        client_id: $scope.locks[index].client_id,
                        alias: $scope.data.rename
                    }
                    CheckMAC.rename(data, function(success) {
                        $scope.loading.hide();
                        var loginObj = JSON.parse(localStorage.getItem('login'));
                        for(var j=0;j<loginObj.locks.length;j++){
                            if(loginObj.locks[j].client_id===$scope.locks[index].client_id){
                                loginObj.currentLockName = $scope.data.rename;
                                loginObj.locks[j].alias=$scope.data.rename;
                                break;
                            }
                        }
                        localStorage.setItem("login", JSON.stringify(loginObj));
                        $scope.locks[index].name = $scope.data.rename;
                        if (!$scope.$$phase) {
                            $scope.$apply();
                        }
                        $scope.data.rename = "";
                    }, function(error) {
                        console.log(error);
                        $scope.loading.hide();
                    });
                }
            }],
        });
    }
    $scope.switch = function(lock) {
        console.log(lock);
        var locks = JSON.parse(localStorage.getItem('locks'));
        var lockName;
        if (locks == null || locks[lock.client_id] == null || locks[lock.client_id] == "") lockName = lock.client_id;
        else lockName = locks[lock.client_id];
        loginObj = JSON.parse(localStorage.getItem('login'));
        loginObj.currentLock = lock.client_id;
        loginObj.currentLockName = lockName;
        loginObj.bleId = lock.ble_id;
        loginObj.macId = lock.mac_id;
        loginObj.lockType = lock.lockType;
        loginObj.passcode = lock.passcode;
        localStorage.setItem('login', JSON.stringify(loginObj));
        $scope.loginObj = loginObj;
        var doorStatus = JSON.parse(localStorage.getItem("doorStatus"));
        doorStatus[loginObj.currentLock] = "close";
        localStorage.setItem("doorStatus", JSON.stringify(doorStatus));
    }
    $scope.setRtc = function(index) {
        $ionicLoading.show();
        var id=$scope.locks[index].ble_id
        var sendString="Rtc " + tools.toBleDateFormat(new Date(), true) + " ";
        ngBLE.connect(id).then(null, function(error){
            console.log(error);
            $ionicLoading.hide();
            tools.toast(error);
        }, function(res){
            if(res.msg==='connected'){
                ngBLE.discover(id).then(function(){
                    ngBLE.subscribe(id).then(null, null, function(success){
                        if(success==='subscribed'){
                            ngBLE.write(id, sendString);
                            tools.toast("Time has been successfully set");
                            ngBLE.disconnect();
                            $ionicLoading.hide();
                        }
                    });
                });
            }else{
                $ionicLoading.hide();
            }
                
        });
    }
    $ionicModal.fromTemplateUrl('edit-lock-modal.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function(modal) {
        $scope.modal = modal;
    });
    $scope.openModal = function(lock, index) {
        console.log($scope.locks[index]);
        $scope.editLock = lock;
        $scope.editLockIndex = index;
        $scope.modal.show();
        var lock = $scope.locks[index];
        var interval = lock.interval;
        if (interval !== undefined && interval !== null) {
            if (interval == 0) {
                $scope.locks[index].interval = "Always on";
            } else if (interval == 0.5) {
                $scope.locks[index].interval = "30 min";
            } else {
                $scope.locks[index].interval = interval + " hr";
            }
        }
    };
    $scope.closeModal = function() {
        $scope.modal.hide();
    };
    $scope.$on('modal.hidden', function() {
        load();
    });
    $scope.$on("$destroy", function() {
        ngBLE.disconnect();
    })
    $scope.setLocation = function(lock, index) {
        var area = "";
        var district = "";
        // $scope.location = lock.locate[0].area + "," + lock.locate[0].district;
        $scope.isDetectingLocation = true;
        var myPopup = $ionicPopup.show({
            templateUrl: "templates/templateUrls/setLocation.html",
            title: "Detecting location",
            scope: $scope,
            buttons: [{
                text: "Cancel"
            }, {
                text: "Ok",
                type: "button-positive",
                onTap: function(e) {
                    e.preventDefault();
                    if ($scope.isDetectingLocation == true) {
                        return;
                    } else {
                        var data = {
                            client_id: $scope.locks[index].client_id,
                            district: district,
                            area: area
                        }
                        http.setLocation(data, function(res) {
                            $scope.locks[index].locate[0] = {
                                area: area,
                                district: district
                            }
                            myPopup.close();
                        }, function(err) {
                            myPopup.close();
                            tools.toast("Could not update location");
                        })
                    }
                }
            }]
        });
        var options = {
            enableHighAccuracy: true,
            maximumAge: 3000
        }
        var watchID = navigator.geolocation.getCurrentPosition(onSuccess, onError, options);

        function onSuccess(position) {
            $scope.isDetectingLocation = false;
            console.log(position);
            var lat = position.coords.latitude;
            var lng = position.coords.longitude;
            $http.get("https://maps.googleapis.com/maps/api/geocode/json?latlng=" + lat + "," + lng + "&sensor=true").then(function(response) {
                console.log(response);
                var data = response.data.results[0].address_components;
                console.log(data);
                var sublocality = false;
                for (var i = 0; i < data.length; i++) {
                    for (var j = 0; j < data[i].types.length; j++) {
                        if (data[i].types[j] === 'sublocality') {
                            sublocality = true;
                            console.log("Area: " + data[i].long_name);
                            area = data[i].long_name;
                            break;
                        }
                    }
                    if (sublocality === false) {
                        for (var j = 0; j < data[i].types.length; j++) {
                            if (data[i].types[j] === 'locality') {
                                sublocality = true;
                                console.log("Area: " + data[i].long_name);
                                area = data[i].long_name;
                                break;
                            }
                        }
                    }
                    for (var k = 0; k < data[i].types.length; k++) {
                        if (data[i].types[k] === 'administrative_area_level_2') {
                            console.log("District: " + data[i].long_name);
                            district = data[i].long_name;
                            break;
                        }
                    }
                }
                console.log("So finally: District: " + district + " and area: " + area);
                $scope.location = area + ", " + district;
            }, function(error) {
                console.log(error);
            });
        };

        function onError(error) {
            console.log(error);
            tools.toast("Could not detect location.");
            myPopup.close();
        }
    }
    $scope.subscribe=function(i){
        var lock=$scope.locks[i];
        $scope.loading.show();
        var id=$scope.locks[i].ble_id;
        var sendString="wsub "+$scope.locks[i].passcode+" ";
        ngBLE.connect(id).then(null, function(error){
            console.log(error);
            $ionicLoading.hide()
            tools.toast(error);
        }, function(res){
            if(res.msg==='connected'){
                ngBLE.discover(id).then(function(){
                    ngBLE.subscribe(id).then(null, null, function(data){
                        if(data==='subscribed'){
                            // ngBLE.write(id, "hitron123/");
                            ngBLE.write(id, sendString);
                        }
                        data=data.trim();
                        if (data == 'changed to BKW') {
                            ngBLE.disconnect();
                            var params={lockType:'BKW', client_id:$scope.locks[i].client_id};
                            http.changeLockType(params).then(function(res){
                                console.log(res);
                                $scope.loading.hide();
                                $scope.loginObj.lockType='BKW';
                                localStorage.setItem('login',JSON.stringify($scope.loginObj));
                                $scope.locks[i].lockType='BKW';
                                db.allDocs({
                                    include_docs: true
                                }, function(error, response) {
                                    if(error){
                                        tools.toast('Database error');
                                        return;
                                    }
                                    var toDelete=[];
                                    for (i = 0; i < response.total_rows; i++) {
                                        var doc = response.rows[i].doc;
                                        if(doc.client_id===loginObj.currentLock){
                                            toDelete.push({id:doc._id, rev:doc._rev});
                                        }
                                    }
                                    if(toDelete.length>0)
                                        var lastID=toDelete[toDelete.length-1];
                                    else{
                                        $ionicPopup.alert({
                                            title:'Success',
                                            subTitle: 'Lock changed.'
                                        });
                                    }
                                    for(var i=0;i<toDelete.length;i++){
                                        db.remove(toDelete[i].id,toDelete.rev, function(err, resp){
                                            console.log(err, (resp)?'deleted': resp);
                                            if(resp.id===lastID){
                                                $ionicPopup.alert({
                                                    title:'Success',
                                                    subTitle: 'Lock changed.'
                                                });
                                            }
                                        });
                                    }
                                });
                                
                                tools.toast(res.msg);
                            }, function(err){
                                console.log(err);
                                $scope.loading.hide();
                                tools.toast(err.msg);
                            });
                                
                            ngBLE.disconnect();
                        }else if(data==='Failed'){
                            $scope.loading.hide();
                        }
                    });
                });
            }else{
                ngBLE.disconnect();
                $scope.loading.hide();
            }   
        });
    }
})
.controller('internetLostCtrl', function($scope, $ionicNavBarDelegate, $ionicLoading, http, tools, $state){
    $ionicNavBarDelegate.showBar(false);
    $scope.loading=$ionicLoading;
    $scope.tryAgain=function(){
        $scope.loading.show();
        var params={
            adminEmail: loginObj.adminName, 
            uuid: (typeof device==='undefined')?'random something':device.uuid
        }
        console.log(params);
        http.isLogged(params).then(function(res){
            $scope.loading.hide();
            if(res.type == false){
                obj = {
                    isLogged: false
                }
                localStorage.setItem('login', JSON.stringify(obj));
                $state.go('login');
            }else{
                loginObj.locks=res.doc;
                console.log(res);
                for(var i=0;i<res.doc.length;i++){
                    if(res.doc[i].client_id===loginObj.currentLock){
                        loginObj.lockType=res.doc[i].lockType;
                        if(res.doc[i].alias)
                            loginObj.currentLockName=res.doc[i].alias;
                        else
                            loginObj.currentLockName=res.doc[i].client_id;
                    }
                }
                localStorage.setItem('login', JSON.stringify(loginObj));
                if(loginObj.locks.length>0){
                    if(loginObj.lockType!=='BKW')
                        $state.go('ble');
                    else
                        $state.go('home');
                }else{
                    $state.go('locks');
                }
            }
        }, function(err){
            console.log(err);
            tools.toast('No internet connection, try again!');
            $scope.loading.hide();
        });
    }
});