angular.module('app.routes', ['ionicUIRouter']).config(function($stateProvider, $urlRouterProvider, $ionicConfigProvider) {
    $stateProvider.state('add_Guest.invite', {
        url: '/page3/:edit',
        cache: false,
        views: {
            'tab1': {
                templateUrl: 'templates/invite.html',
                controller: 'inviteCtrl'
            }
        }
    }).state('add_Guest.permissions', {
        url: '/page4/:edit',
        cache: false,
        views: {
            'tab2': {
                templateUrl: 'templates/permissions.html',
                controller: 'permissionsCtrl' //permissionsCtrl
            }
        }
    }).state('guestSettings', {
        url: "/guestSettings",
        cache: false,
        templateUrl: "templates/guestSettings.html",
        controller: "guestSettingsCtrl"
    }).state('add_Guest.guestRole', {
        url: '/page5/:edit',
        cache: false,
        views: {
            'tab3': {
                templateUrl: 'templates/guestRole.html',
                controller: 'guestRoleCtrl'
            }
        }
    }).state('add_Guest', {
        url: '/addGuest',
        cache: false,
        templateUrl: 'templates/add_Guest.html',
        controller: 'tabsCtrl'
    }).state('login', {
        url: '/adminLogin',
        cache: false,
        templateUrl: 'templates/login.html',
        controller: 'loginCtrl'
    }).state('guestLogin', {
        url: '/guestLogin',
        cache: false,
        templateUrl: 'templates/guestLogin.html',
        controller: 'loginCtrl'
    }).state('signup', {
        url: '/signup',
        cache: false,
        templateUrl: 'templates/signup.html',
        controller: 'signupCtrl'
    }).state('guests', {
        url: '/guests',
        cache: false,
        templateUrl: 'templates/guests.html',
        controller: 'guestsCtrl'
    }).state('guestActivity', {
        url: '/guestActivity/:guest',
        cache: false,
        templateUrl: 'templates/getActivity.html',
        controller: 'guestActivityCtrl'
    }).state('ble', {
        url: '/page17',
        cache: false,
        templateUrl: 'templates/ble.html',
        controller: 'bleCtrl'
    }).state('notifications', {
        url: '/page10',
        cache: false,
        templateUrl: 'templates/notifications.html',
        controller: 'notificationsCtrl'
    }).state('lockSetup', {
        url: '/page11',
        cache: false,
        templateUrl: 'templates/lockSetup.html',
        controller: 'lockSetupCtrl'
    }).state('battery', {
        url: '/page12',
        cache: false,
        templateUrl: 'templates/battery.html',
        controller: 'batteryCtrl'
    }).state('keypad', {
        url: '/page13',
        cache: false,
        templateUrl: 'templates/keypad.html',
        controller: 'keypadCtrl'
    }).state('home', {
        cache: false,
        url: '/page15', //'/:user
        templateUrl: 'templates/home.html',
        controller: 'homeCtrl'
    }).state('addLock', {
        cache: false,
        url: '/addLock',
        templateUrl: 'templates/add_lock.html',
        controller: 'addLockCtrl'
    }).state('locks', {
        cache: false,
        url: '/locks',
        templateUrl: 'templates/locks.html',
        controller: 'locksCtrl'
    }).state('BLELogin', {
        cache: false,
        url: '/BLELogin/:id',
        templateUrl: "templates/BLELogin.html",
        controller: "BLELoginCtrl"
    }).state('BLEGuestAdd', {
        cache: false,
        url: '/BLEGuestAdd/:edit',
        templateUrl: "templates/BLEGuestAdd.html",
        controller: "BLEGuestAddCtrl"
    }).state('internetLost', {
        url: '/internetLost',
        cache: false,
        templateUrl: "templates/internetLost.html",
        controller: "internetLostCtrl"
    });
    $urlRouterProvider.otherwise('/internetLost');
});