var url = 'https://locksmanager.com:4002';
// var url = 'http://192.168.1.100:4001';
// var url="http://localhost:4001";
angular.module('app.services', [])
.factory('http', function($http, $q) {
    return {
        interval: function(data, success, error) {
            $http.post(url + '/updateInterval', data).success(success).error(error);
        },
        getNotification: function(data) {
            var deferred = $q.defer();
            $http.post(url + '/notifications', data).then(function(obj){
                deferred.resolve(obj.data);
            }, function(obj){
                if(obj.status===-1){
                    obj.data={
                        msg:"No internet connection"
                    }
                }
                deferred.reject(obj.data);
            });
            return deferred.promise;
        },
        setLocation: function(data, success, error) {
            $http.post(url + '/addLocation', data).success(success).error(error);
        },
        enableDisable: function(data) {
            var deferred = $q.defer();
            $http.post(url + '/enableGuest', data).then(function(obj){
                deferred.resolve(obj.data);
            }, function(obj){
                if(obj.status===-1){
                    obj.data={
                        msg:"No internet connection"
                    }
                }
                deferred.reject(obj.data);
            });
            return deferred.promise;
        },
        toDelete: function(data, success, error) {
            $http.post(url + '/deletedFromDash', data).success(success).error(error);
        },
        logout: function(data, success, error) {
            $http.post(url + '/logout', data).success(success).error(error);
        },
        isLogged: function(data) {
            var deferred = $q.defer();
            $http.post(url + '/isLogged', data).then(function(obj){
                deferred.resolve(obj.data);
            }, function(obj){
                console.log(obj);
                if(obj.status===-1){
                    obj.data={
                        msg:"No internet connection"
                    }
                }
                deferred.reject(obj.data);
            });
            return deferred.promise;
        },
        addGuest: function(data) {
            var deferred = $q.defer();
            $http.post(url + '/guests', data).then(function(obj){
                deferred.resolve(obj.data);
            }, function(obj){
                if(obj.status===-1){
                    obj.data={
                        msg:"No internet connection"
                    }
                }
                deferred.reject(obj.data);
            });
            return deferred.promise;
        },
        deleteGuest: function(data) {
            var deferred = $q.defer();
            $http.post(url + '/guestdelete', data).then(function(obj){
                deferred.resolve(obj.data);
            }, function(obj){
                if(obj.status===-1){
                    obj.data={
                        msg:"No internet connection"
                    }
                }
                deferred.reject(obj.data);
            });
            return deferred.promise;
        },
        changeLockType: function(data) {
            var deferred = $q.defer();
            $http.post(url + '/changeLockType', data).then(function(obj){
                deferred.resolve(obj.data);
            }, function(obj){
                console.log(obj);
                if(obj.status===-1){
                    obj.data={
                        msg:"No internet connection"
                    }
                }
                deferred.reject(obj.data);
            });
            return deferred.promise;
        },
        getBleId: function(data) {
            var deferred = $q.defer();
            $http.post(url + '/getBleId', data).then(function(obj){
                deferred.resolve(obj.data);
            }, function(obj){
                console.log(obj);
                if(obj.status===-1){
                    obj.data={
                        msg:"No internet connection"
                    }
                }
                deferred.reject(obj.data);
            });
            return deferred.promise;
        },
        adminLogin: function(data) {
            var deferred = $q.defer();
            $http.post(url + '/login', data).then(function(obj){
                deferred.resolve(obj.data);
            }, function(obj){
                console.log(obj);
                if(obj.status===-1){
                    obj.data={
                        msg:"No internet connection"
                    }
                }
                deferred.reject(obj.data);
            });
            return deferred.promise;
        },
        findGuests: function(data) {
            var deferred = $q.defer();
            $http.post(url + '/findGuests', data).then(function(obj){
                deferred.resolve(obj.data);
            }, function(obj){
                console.log(obj);
                if(obj.status===-1){
                    obj.data={
                        msg:"No internet connection"
                    }
                }
                deferred.reject(obj.data);
            });
            return deferred.promise;
        }
    }
}).factory('publish', function() {
    return {
        pub: function(data) {
            console.log(data);
            client.publish(data.topic, data.payload, {
                retain: true
            });
        },
        sub: function(data) {
            console.log(data);
            client.subscribe(data.topic);
        }
    }
}).factory('logIn', function($http) {
    return {
        authenticate: function(data, success, error) {
            console.log('In services', data);
            $http.post(url + '/login', data).success(success).error(error);
        }
    }
}).factory('GuestList', function($http) {
    return {
        getGuestList: function(data, success, error) {
            console.log(data);
            $http.post(url + '/findGuests', data).success(success).error(error);
        }
    }
}).factory('guestlogIn', function($http) {
    return {
        authenticate: function(data, success, error) {
            console.log('In services', data);
            $http.post(url + '/guestAuth', data).success(success).error(error);
        },
        update: function(data, success, error) {
            console.log('Update:');
            console.log(data);
            $http.post(url + '/guestUpdate', data).success(success).error(error);
        }
    }
}).factory('registered', function($http) {
    return {
        register: function(data, success, error) {
            console.log('In services', data);
            $http.post(url + '/signup', data).success(success).error(error);
        }
    }
}).factory('CheckMAC', function($http) {
    return {
        verify: function(data, success, error) {
            console.log(data);
            $http.post(url + '/appAddProduct', data).success(success).error(error);
        },
        rename: function(data, success, error) {
            console.log(data);
            $http.post(url + '/alias', data).success(success).error(error);
        }
    }
}).factory('Devicefactory', function($http, socket) {
    return {
        publish: function(data) {
            console.log(data);
            socket.emit('/device/control', data);
            /*return $http.post(ipServer + '/device', data)
            {
                  console.log(data);
            }*/
        }
    };
}).factory('Subscription', function($http, socket) {
    return {
        sub: function(data) {
            console.log(data);
            socket.emit('subscribe', data);
        }
    };
}).factory('checkKeypad', function($http) {
    return {
        verify: function(data, success, error) {
            console.log('In services', data);
            $http.post(url + '/adminChangeKey', data).success(success).error(error);
        }
    }
}).factory('MQTT', function() {
    return {
        pub: function(data) {
            console.log(data.topic, data.payload);
            client.publish(data.topic, data.payload);
        },
        sub: function(data) {
            console.log(data);
            client.subscribe(data.topic);
        }
    }
}).factory("gener", function() {
    return {
        doAlert: function(title, msg) {
            console.log(title, msg);
            //navigator.notification.alert(message, alertCallback, title, buttonName);
            navigator.notification.alert(msg, null, title, 'OK');
        },
        doConfirm: function(title, msg, scope) {
            navigator.notification.confirm(msg, null, title, ['Submit', 'Cancel']);
        }
    }
}).factory('getMac', function($http) {
    return {
        api: function(productID, success, error) {
            var data = {
                client_id: productID
            }
            $http.post(url + '/mac4Guest', data).success(success).error(error);
        }
    }
}).factory('Devices', function() {
    // Might use a resource here that returns a JSON array
    // Some fake testing data
    var devices = [];
    return {
        all: function() {
            return devices;
        },
        clean: function() {
            devices.splice(0, devices.length);
        },
        remove: function(device) {
            devices.splice(devices.indexOf(device), 1);
        },
        get: function(deviceId) {
            for (var i = 0; i < chats.length; i++) {
                if (devices[i].id === parseInt(deviceId)) {
                    return devices[i];
                }
            }
            return null;
        },
        add: function(device) {
            devices.push(device);
        }
    };
}).factory('guestTimeout', function() {
    var checkOut;
    var ret = {
        getTime: function() {
            try {
                var loginObj = JSON.parse(localStorage.getItem('login'));
            } catch (e) {
                console.log(e);
            }
            if (loginObj != null) {
                if (loginObj.type == 'guest') {
                    checkOut = loginObj.checkOut;
                }
            }
            return checkOut;
        },
        checkLogin: function() {
            var login = false;
            var loginObj = JSON.parse(localStorage.getItem('login'));
            if (loginObj == null || loginObj.isLogged == false) {
                login = false;
            } else {
                login = true;
                if (loginObj.type == 'admin') {
                    login = false;
                }
            }
            return login;
        },
        getTimeRemaining: function(checkOut) {
            var t = Date.parse(checkOut) - Date.parse(new Date());
            var seconds = Math.floor((t / 1000) % 60);
            var minutes = Math.floor((t / 1000 / 60) % 60);
            var hours = Math.floor((t / (1000 * 60 * 60)) % 24);
            var days = Math.floor(t / (1000 * 60 * 60 * 24));
            return {
                'total': t,
                'days': days,
                'hours': hours,
                'minutes': minutes,
                'seconds': seconds
            };
        }
    }
    return ret;
}).factory('ngBLE', function($q, Devices, tools, $ionicLoading) {
    var currentID = "";
    var connectDeferred;
    var ret = {
        service:"ffe0",
        characteristic: "ffe1",
        ifBrowser:function(){
            try{
                if(bluetoothle === null)
                    return false;
                else
                    return true;
            }catch(e){
                return false;
            }
        },
        reject: function(deferred){
            setTimeout(function() {
                deferred.reject({msg:"bluetoothle not supported in browser."});
            }, 1000);
        },
        initialize: function() {
            var deferred = $q.defer();
            if(!ret.ifBrowser()){
                ret.reject(deferred);
                return;
            }
            bluetoothle.initialize(function(res){
                console.log(res);
                if(res.status==='disabled'){
                    // tools.toast("Bluetooth is not enabled");
                    bluetoothle.enable(function(res){
                        console.log(res);
                        deferred.resolve({title: 'initialize', msg: 'Bluetooth initialized.'});
                    }, function(res){
                        console.log(res);
                        deferred.reject({title: 'initialize', msg: 'Bluetooth not enabled.'})
                    });
                }else{
                    deferred.resolve({title: 'initialize', msg: 'Bluetooth initialized.'});
                }
            },{
                statusReceiver:true
            });
            return deferred.promise;
        },
        connect: function(id) {
            connectDeferred = $q.defer();
            if(!ret.ifBrowser()){
                ret.reject(connectDeferred);
                return connectDeferred.promise;
            }
            currentID=id;
            var connected=false;
            ret.initialize().then(function(res){
                bluetoothle.connect(function(res){
                    console.log(res);
                    if(res.status == 'connected'){
                        console.log("Connected:", id);
                        connected=true;
                        setTimeout(function() {
                            connectDeferred.notify({title: 'connect', msg: 'connected', add: res.address});
                        }, 1000);
                    }else if(res.status==='disconnected'){
                        console.log("Disconnected:", id);
                        bluetoothle.close(function(res){
                            tools.toast("Lock disconnected.");
                            connectDeferred.reject({title: 'connect', msg: 'Lock Disconnected'});
                        }, function(res){
                            connectDeferred.reject({title: 'connect', msg: 'Lock Disconnected'});
                            tools.toast("Lock disconnected.");
                        }, {address: currentID});
                    }
                }, function(err){
                    console.log(err.message);
                    tools.toast("Disconnected");
                    bluetoothle.close(function(res){
                        connectDeferred.reject({title: 'connect', msg: 'Lock Disconnected'});
                    }, function(res){
                        connectDeferred.reject({title: 'connect', msg: 'Lock Disconnected'});
                    }, {address: currentID});
                },{address: id});
            },function(err){
                connectDeferred.reject({title: 'connect', msg: err.msg});
            });
            return connectDeferred.promise;
        },
        write: function(id, data) {
            var deferred = $q.defer();
            if(!ret.ifBrowser()){
                ret.reject(deferred);
                return;
            }
            var sendString = data;
            var bytes = bluetoothle.stringToBytes(sendString);
            var encodedString = bluetoothle.bytesToEncodedString(bytes);
            bluetoothle.writeQ(function(res){
                console.log("Write successful:", data);
                deferred.resolve(res);
            }, function(err){
                console.log(err);
                deferred.reject(err);
            }, {
                address: id,
                service: ret.service,
                characteristic: ret.characteristic,
                value: encodedString,
                type: "noResponse"
            });
            return deferred.promise;
        },

        discover: function(id, newLock) {
            var deferred = $q.defer();
            if(!ret.ifBrowser()){
                ret.reject(deferred);
                return;
            }
            bluetoothle.discover(function(res){
                console.log("Discovered:", id);
                if(newLock){
                    ret.write(id, newLock+"/");
                }else{
                    var loginObj=JSON.parse(localStorage.getItem("login"));
                    ret.write(id, loginObj.passcode+"/");
                }
                deferred.resolve(res);
            }, function(err){
                console.log(err);
                deferred.reject(err);
            }, {
                address: id
            })
            return deferred.promise;
        },

        subscribe: function(id){
            var deferred = $q.defer();
            if(!ret.ifBrowser()){
                ret.reject(deferred);
                return;
            }
            bluetoothle.subscribe(function(res){
                if(res.status == 'subscribedResult'){
                    try{
                        var bytes = bluetoothle.encodedStringToBytes(res.value);
                        var receivedString = bluetoothle.bytesToString(bytes);
                        deferred.notify(receivedString);
                    }catch(e){
                        console.log(e);
                    }
                }else if(res.status=='subscribed'){
                    deferred.notify(res.status);
                }
                console.log((res.status==='subscribed')?"subscribed":receivedString);
            }, function(err){
                console.log(err);
                deferred.resolve(err);
            }, {
                address: id,
                service: ret.service,
                characteristic: ret.characteristic
            });
            return deferred.promise;
        },
        disconnect: function(from){
            var deferred = $q.defer();
            if(!ret.ifBrowser()){
                ret.reject(deferred);
                return;
            }
            bluetoothle.close(function(res){
                console.log("Device closed.", currentID);
                if(from==='back button' && connectDeferred){
                    $ionicLoading.hide();
                    connectDeferred.reject({title: 'connect', msg: 'Lock Disconnected'});
                }
                deferred.resolve(res);
            }, function(err){
                console.log("Device close unsuccesful:", err.error);
                if(from==='back button' && connectDeferred){
                    $ionicLoading.hide();
                    connectDeferred.reject({title: 'connect', msg: 'Lock Disconnected'});
                }
                deferred.reject(err);
            }, {address: currentID});
            return deferred.promise;
        }
    }
    return ret;
}).factory('tools', function($filter, $ionicLoading, $http) {
    var ret = {
        toast: function(message) {
            if(!message)
                return;
            if (window && window.plugins && window.plugins.toast) {
                window.plugins.toast.showWithOptions({
                    message: message,
                    duration: "short",
                    position: "bottom",
                    styling: {
                        opacity: 0.8, // 0.0 (transparent) to 1.0 (opaque). Default 0.8 
                        backgroundColor: '#333333', // make sure you use #RRGGBB. Default #333333 
                        textColor: '#FFFFFF', // Ditto. Default #FFFFFF 
                        textSize: 13, // Default is approx. 13. 
                        cornerRadius: 100, // minimum is 0 (square). iOS default 20, Android default 100 
                        horizontalPadding: 50, // iOS default 16, Android default 50 
                        verticalPadding: 30 // iOS default 12, Android default 30 
                    }
                });
            }
        },
        toBleDateFormat: function(date, rtc) {
            date = new Date(date);
            var bleDate = $filter('date')(date, 'HH:mm:ss/dd:MM:yy');
            if (rtc !== null && rtc === true) {
                bleDate = $filter('date')(date, 'ss,mm,HH,' + (date.getDay() + 1) + ',dd,MM,yy');
            }
            console.log(bleDate);
            return bleDate;
        },
        open: function() {
            $scope.data.lockBool = true;
            $scope.data.backgroundColor = "#4bd248";
            $scope.state = "UnLocked";
            var doorStatus = JSON.parse(localStorage.getItem("doorStatus"));
            doorStatus[loginObj.currentLock] = "open";
            localStorage.setItem("doorStatus", JSON.stringify(doorStatus));
        },
        parse: function(timeData) {
            var d = new Date();
            timeData=timeData.split('/');
            var time=timeData[0];
            time=time.split(":");
            var date=timeData[1];
            date=date.split(":");
            console.log(time, date);
            d.setFullYear(Number("20" + date[2].substring(0,2)), Number(date[1]) - 1, Number(date[0]));
            d.setHours(Number(time[0]));
            d.setMinutes(Number(time[1]));
            d.setSeconds(Number(time[2]))
            console.log(d.toString());
            return d;
        },
        load: function(duration, text) {
            document.getElementById('loadingArea').style.display = "block";
            if (text !== undefined) {
                console.log("hello");
                document.getElementById('loadText').innerHTML = text;
            } else {
                document.getElementById('loadText').style.display = "none";
            }
            console.log(document.getElementById('loadingArea').style.display);
            if (duration === 0) {
                return;
            }
            setTimeout(function() {
                document.getElementById('loadingArea').style.display = "none";
            }, duration);
        },
        hideLoad: function() {
            /* $ionicLoading.hide();*/
            console.log("load hide");
            document.getElementById('loadingArea').style.display = "none";
        },
        isLoading: function() {
            console.log(document.getElementById('loadingArea').style.display === "block");
            if (document.getElementById('loadingArea').style.display === "block") return true;
            else return false;
        },
        batteryApi: function(data, success, error) {
            console.log(data);
            $http.post(url + '/battery', data).success(success).error(error);
        }
    }
    return ret;
});